#!/usr/bin/perl
#################################################################################
#										#
# This program is free software; you can redistribute it and/or			#
# modify it under the terms of the GNU General Public License			#
# as published by the Free Software Foundation; either version 3		#
# of the License, or (at your option) any later version.			#
#										#
# This program is distributed in the hope that it will be useful,		#
# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
# General Public License for more details.					#
#										#
# You should have received a copy of the GNU General Public			#
# License along with this library; if not, write to the				#
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
# Boston, MA 02111-1307, USA.							#
#										#
#################################################################################
use POSIX;
use Fcntl;

$dummy=`echo ".set ctype = 8" > config.inc`;
print `avra main.asm`;

$dummy=`hex2bin main.hex`;

$binfile="main.bin";
$datfile=">../src/avr_proto8.c";
$head="avr_proto8";

&gencode;

$dummy=`echo ".set ctype = 88" > config.inc`;
print `avra main.asm`;
$dummy=`hex2bin main.hex`;

$binfile="main.bin";
$datfile=">../src/avr_proto88.c";
$head="avr_proto88";

&gencode;




sub gencode
{
	for($i=0;$i<8192;$i++)
	{
		$romdata[$i]=255;
	}

	$dlen = -s $binfile;
	open (BREAD, $binfile);
	binmode(BREAD);
	for($i=0;$i<$dlen;$i++)
	{
		read(BREAD,$romdata[$i],1);
	}
	close(BREAD);

	$dlen=8192;

	open (DWRITE,$datfile);
	print DWRITE "unsigned char ".$head."[$dlen] = {";


	for($i=0;$i<$dlen;$i++)
	{
		if(($i%16)==0)
		{
			print DWRITE "\n\t\t";
		}
		$ibyte=$romdata[$i];
		$iwert=ord($ibyte);
		if($iwert==0)
		{
			print DWRITE "0x00";
		}
		else
		{
			printf DWRITE "%#2.2x",$iwert;
		}
		if($i<($dlen-1))
		{
			print DWRITE ",";
		}
	}
	print DWRITE "};\n";

	close(DWRITE);
}

