#!/usr/bin/perl
#################################################################################
#										#
# segment calculator								#
# copyright (c) 2012-2013 Joerg Wolfram (joerg@jcwolfram.de)			#
#										#
# This program is free software; you can redistribute it and/or			#
# modify it under the terms of the GNU General Public License			#
# as published by the Free Software Foundation; either version 3		#
# of the License, or (at your option) any later version.			#
#										#
# This program is distributed in the hope that it will be useful,		#
# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
# General Public License for more details.					#
#										#
# You should have received a copy of the GNU General Public			#
# License along with this library; if not, write to the				#
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
# Boston, MA 02111-1307, USA.							#
#										#
#################################################################################
use POSIX;
use Fcntl;

#           "6543210"
$segments = "gfeabdc";	#segment mapping at port D

$csetfile=">segtab.inc";

$dlen = -s $binfile;

open (DWRITE,$csetfile);
for($i=0;$i<256;$i++)
{
	$sdata[$i]=0;
}

for($sa=0;$sa<2;$sa++)
{
	for($sb=0;$sb<2;$sb++)
	{
		for($sc	=0;$sc<2;$sc++)
		{
			for($sd	=0;$sd<2;$sd++)
			{
				for($se=0;$se<2;$se++)
				{
					for($sf=0;$sf<2;$sf++)
					{
						for($sg=0;$sg<2;$sg++)
						{
							$value = 0;
							$pos = $sa + 2*$sb + 4*$sc + 8*$sd + 16*$se + 32*$sf +64*$sg;
							if($sa == 1)
							{
								for($i=0;$i<7;$i++)
								{
									if(substr($segments,$i,1) eq 'a')
									{
										$value += 1 << (6-$i);
									}
								}
							}
							if($sb == 1)
							{
								for($i=0;$i<7;$i++)
								{
									if(substr($segments,$i,1) eq 'b')
									{
										$value += 1 << (6-$i);
									}
								}
							}
							if($sc == 1)
							{
								for($i=0;$i<7;$i++)
								{
									if(substr($segments,$i,1) eq 'c')
									{
										$value += 1 << (6-$i);
									}
								}
							}
							if($sd == 1)
							{
								for($i=0;$i<7;$i++)
								{
									if(substr($segments,$i,1) eq 'd')
									{
										$value += 1 << (6-$i);
									}
								}
							}
							if($se == 1)
							{
								for($i=0;$i<7;$i++)
								{
									if(substr($segments,$i,1) eq 'e')
									{
										$value += 1 << (6-$i);
									}
								}
							}
							if($sf == 1)
							{
								for($i=0;$i<7;$i++)
								{
									if(substr($segments,$i,1) eq 'f')
									{
										$value += 1 << (6-$i);
									}
								}
							}
							if($sg == 1)
							{
								for($i=0;$i<7;$i++)
								{
									if(substr($segments,$i,1) eq 'g')
									{
										$value += 1 << (6-$i);
									}
								}
							}

							$sdata[$pos]=$value;
							$sdata[$pos+128]=$value+128;
						}
					}
				}
			}
		}
	}
}



for($i=0;$i<256;$i++)
{
	if(($i%16)==0)
	{
		print DWRITE "\t\t.db ";
	}
	$iwert=$sdata[$i];
	if($iwert==0)
	{
		print DWRITE "0x00";
	}
	else
	{
		printf DWRITE "%#2.2x",$iwert;
	}
	if(($i%16)<15)
	{
		print DWRITE ",";
	}
	else
	{
		printf DWRITE "\n"; 
	}
	
}


close(DWRITE);

