#!/usr/bin/perl
################################################################################################
#
# tile-generator
#
################################################################################################ 
use POSIX;

$tileindex=0;
$grey_color   = "\"w	c #A1A1A1\",";
$select_color = "\"x	c #FFB400\",";
$text_color   = "\"y	c #000000\",";
$conn_color   = "\"z	c #FFFF40\",";
$max_lang=0;

$dummy=`rm -f ../pixmaps/tiles60/*`;
$dummy=`rm -f ../pixmaps/tiles40/*`;

#Maskenset einlesen
for($z=0;$z<31;$z++)
{
	$zz=sprintf("mask/mask_%02d.xpm",$z);
#	printf $zz."\n";
	open(CFILE,$zz);
	$y=0;
	while(<CFILE>)
	{
		chomp;
		$line=$_;
		if(length($line)>60)
		{
			for($x=1;$x<61;$x++)
			{
				$maskset[$z][$y][$x-1]=0;
				if(substr($line,$x,1) ne " ")
				{
					$maskset[$z][$y][$x-1]=1;
				}
			}
		$y++;
		}
	}
	close(CFILE);
}


#tileliste einlesen
$list_index=0;
open(CFILE,"tilelist.dat");
while(<CFILE>)
{
	chomp;
	$pc_line=$_;
	if((length($pc_line) > 10) && (substr($pc_line,0,1) ne "-") && (substr($pc_line,0,2) ne "+L"))
	{
		@pc_tmp=split(/\t/ , $pc_line);
		$i=0;
		$tile_num[$tileindex] = $pc_tmp[$i++]+0;
		if(($tile_num[$tileindex]>5) && ($tile_num[$tileindex]<100))
		{
			$element_list[$list_index++]=$tile_num[$tileindex];
		}
		if($pc_tmp[$i] eq ""){$i++;}
		if($pc_tmp[$i] eq ""){$i++;}
		$tile_file[$tileindex] = $pc_tmp[$i++].".xpm";
		if($pc_tmp[$i] eq ""){$i++;}
		if($pc_tmp[$i] eq ""){$i++;}
		$tile_tiptext[$tileindex] = $pc_tmp[$i++];
		if($pc_tmp[$i] eq ""){$i++;}
		if($pc_tmp[$i] eq ""){$i++;}
		if($pc_tmp[$i] eq ""){$i++;}
		if($pc_tmp[$i] eq ""){$i++;}
		$tile_adjtext[$tileindex] = $pc_tmp[$i++];
		if($pc_tmp[$i] eq ""){$i++;}
		if($pc_tmp[$i] eq ""){$i++;}
		if($pc_tmp[$i] eq ""){$i++;}
		if($pc_tmp[$i] eq ""){$i++;}
		$default[$tileindex] = $pc_tmp[$i++]+0;
		if($pc_tmp[$i] eq ""){$i++;}
		if($pc_tmp[$i] eq ""){$i++;}
		if($pc_tmp[$i] eq ""){$i++;}
		if($pc_tmp[$i] eq ""){$i++;}
		$minimum[$tileindex] = $pc_tmp[$i++]+0;
		if($pc_tmp[$i] eq ""){$i++;}
		if($pc_tmp[$i] eq ""){$i++;}
		if($pc_tmp[$i] eq ""){$i++;}
		if($pc_tmp[$i] eq ""){$i++;}
		$maximum[$tileindex] = $pc_tmp[$i++]+0;
		$lti=$tileindex;
		$tile_ltxt[$lti][1] = "---";
		$tile_atxt[$lti][1] = "---";
		$tile_ltxt[$lti][2] = "---";
		$tile_atxt[$lti][2] = "---";
		$tile_ltxt[$lti][3] = "---";
		$tile_atxt[$lti][3] = "---";
		$tile_ltxt[$lti][4] = "---";
		$tile_atxt[$lti][4] = "---";

#		printf("Num: %d File: %s\n",$tile_num[$tileindex],$tile_file[$tileindex]);
#		printf("TIP= %s\nADJ= %s\n",$tile_tiptext[$tileindex],$tile_adjtext[$tileindex]);
#		printf("DEF: %d   MIN: %s   MAX: %d\n",$default[$tileindex],$minimum[$tileindex],$maximum[$tileindex]);	
		$tileindex++;
	}
	if((length($pc_line) > 4) && (substr($pc_line,0,2) eq "+L"))
	{
		@pc_tmpx=split(/\t/ , $pc_line);
		$j=$pc_tmpx[1]+0;

#		printf "LANG=".$j." TI = $lti\n";
		if($j > $max_lang)
		{
			$max_lang = $j;
		}
		$tile_ltxt[$lti][$j] = $pc_tmpx[2];
		$tile_atxt[$lti][$j] = $pc_tmpx[3];
	}
}
close(CFILE);

#elementliste
open(DFILE,">../src/ele_list.c");
printf(DFILE "static unsigned char ele_list\[\] = {\n");
printf(DFILE "%d,\n",$list_index);
for($i=0;$i<$list_index;$i++)
{
	printf(DFILE "%d,\n",$element_list[$i]);
}
printf(DFILE "255\n};\n");
close(DFILE);

#tiles schreiben und datafile

open(DFILE,">../src/set_tiledat.c");
printf(DFILE "static unsigned char tiledat\[\] = {\n");

open(VFILE,">../src/set_tileval.c");
printf(VFILE "static unsigned char tileval\[\] = {\n");


for($tile=0;$tile<$tileindex;$tile++)
{
	for($xmode=0;$xmode<3;$xmode++)
	{
		for($index=0;$index<31;$index++)
		{
			if(($index==0) || (($index >= $minimum[$tile]) && ($index <= $maximum[$tile])))
			{
			$mode=$xmode;
#			if($tile==0)
#			{
#				$mode=0;
#			}
			$z1=sprintf("_%03d",$tile_num[$tile]);
			$z2=sprintf("_%01d",$xmode);
			$z3=sprintf("_%02d",$index);
			$filename=">../pixmaps/tiles60/tile$z1$z2$z3.xpm";
			open(WFILE,$filename);
			open(RFILE,$tile_file[$tile]);
			$izeile=1;
			$zeile=1;
			printf(WFILE "/* XPM */\n");
			printf(WFILE "static char * tile$z1$z2$z3\[\] = {\n");
			if($mode == 0)
			{
				printf(DFILE "// tile$z1$z2$z3\n");
				printf(VFILE "%d,%d,\n",$tile_num[$tile],$index);
			}
			$temp=<RFILE>;
			$temp=<RFILE>;
			$temp=<RFILE>;
			@tmp=split(/ / , $temp);
			$colors=$tmp[2]+4;
			printf(WFILE "\"60 60 $colors 1\",\n");
			$pal_num=1;
			while(<RFILE>)
			{
				chomp;
				$line=$_;
				if(length($line)<50)
				{
					printf(WFILE "%s\n",$line);
					$pc[$pal_num-1]=substr($line,1,1);
					if(index($line,"#") > 0)
					{
						$red=substr($line,6,2);
						$green=substr($line,8,2);
						$blue=substr($line,10,2);
					}
					else
					{
						$red = "00";
						$green = "00";
						$blue = "00";
					}
					if($mode == 0)
					{
						printf(DFILE "0x%s,0x%s,0x%s,",$red,$green,$blue);
						if(($pal_num % 8) == 0)
						{
							printf(DFILE "\n");
						}
					}
					$pal_num++;
				}
				else
				{
					$done=0;

					#erste Zeile wird komplett ersetzt
					if($zeile==1)
					{
						if($mode == 0)
						{
							for($pn=$pal_num;$pn<=64;$pn++)
							{
								$pc[$pn-1]="OO";
								$red = "00";
								$green = "00";
								$blue = "00";
								printf(DFILE "0x%s,0x%s,0x%s,",$red,$green,$blue);
								if(($pn % 8) == 0)
								{
									printf(DFILE "\n");
								}
							}
							printf(DFILE "0x61,0x61,0x61,0xFF,0xB4,0x00,0x00,0x00,0x00,0xFF,0xFF,0x40,\n");
						}
						printf(WFILE "\"w	c #616161\",\n");
						printf(WFILE "\"x	c #FFB400\",\n");
						printf(WFILE "\"y	c #000000\",\n");
						printf(WFILE "\"z	c #FFFF40\",\n");
						$pc[64]="w";
						$pc[65]="x";
						$pc[66]="y";
						$pc[67]="z";
						$replace=substr($line,2,1);
						if($mode==0) 
						{
							pixline("\"wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww\",");
						}
						if($mode==1) 
						{
							pixline("\"xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\",");
						}
						if($mode==2) 
						{
							pixline("\"zzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz\",");
						}
						$zeile++;
						$done=1;
					}
				
					#letzte Zeile wird komplett ersetzt
					if($zeile==60)
					{
						if($mode==0) 
						{
							pixline("\"wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww\"};\n");
						}
						if($mode==1) 
						{
							pixline("\"xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\"};\n");
						}
						if($mode==2) 
						{
							pixline("\"zzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz\"};\n");
						}
						$zeile++;
						$done=1;
					}

					#die restlichen Zeilen in Mode 0
					if(($mode == 0) && ($done == 0))
					{
						substr($line,1,1)="w";
						substr($line,60,1)="w";
						for($p=0;$p<60;$p++)
						{
							if(($maskset[$index][$zeile-1][$p]==1) && (substr($tile_adjtext[$tile],0,1) ne "-"))
							{
								substr($line,$p,1)="y";
							}
						}
						pixline($line);
				#		printf(WFILE "%d\n",$zeile);
						$zeile++;
						$done=1;
					}
							
					if(($zeile==2) && ($mode==1)&& ($done == 0))
					{
						pixline("\"xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\",");
						$zeile++;
						$done=1;
					}
					
					if(($zeile==59) && ($mode==1)&& ($done == 0))
					{
						pixline("\"xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\",");
						$zeile++;
						$done=1;
					}

					#die restlichen Zeilen in Mode 1
					if(($mode == 1) && ($done == 0))
					{
						substr($line,1,2)="xx";
						substr($line,59,2)="xx";
						for($p=0;$p<60;$p++)
						{
							if(($maskset[$index][$zeile-1][$p]==1) && (substr($tile_adjtext[$tile],0,1) ne "-"))
							{
								substr($line,$p,1)="y";
							}
						}
						pixline($line);
						$zeile++;
						$done=1;
					}

					#die restlichen Zeilen in Mode 2
					if(($mode == 2) && ($done == 0))
					{
						for($p=0;$p<61;$p++)
						{
							if(substr($line,$p,1) eq $replace)
							{
								substr($line,$p,1)="z";
							}

							if(($maskset[$index][$zeile-1][$p]==1) && (substr($tile_adjtext[$tile],0,1) ne "-"))
							{
								substr($line,$p,1)="y";
							}
						}
						pixline($line);
						$zeile++;
						$done=1;
					}
					if($done == 0)
					{
						print "not done! \n";
					}
				} #else
			}#wfile	
			close(RFILE);
			close(WFILE);
			$cmd = "convert -resize 40x40 -unsharp 2x2 ../pixmaps/tiles60/tile$z1$z2$z3.xpm -size 40x40 -depth 8 -colors 64 ../pixmaps/tiles40/tile$z1$z2$z3.xpm";
			$dummy = `$cmd`;
			} #if
		}
	}
}

printf(DFILE "255\n};\n");
close(DFILE);
printf(VFILE "255,255\n};\n");
close(VFILE);

open(WFILE,">../src/load_pixmaps60.c");

for($tile=0;$tile<$tileindex;$tile++)
{
	for($mode=0;$mode<3;$mode++)
	{
		for($index=0;$index<31;$index++)
		{
			if(($index==0) || (($index >= $minimum[$tile]) && ($index <= $maximum[$tile])))
			{
				$z1=sprintf("_%03d",$tile_num[$tile]);
				$z2=sprintf("_%01d",$mode);
				$z3=sprintf("_%02d",$index);
				$filename="#include \"../pixmaps/tiles60/tile$z1$z2$z3.xpm\"";
				printf(WFILE "%s\n",$filename);
			}
		}
	}
}

printf(WFILE "\n");
printf(WFILE "\n");
printf(WFILE "void load_pixmaps(GtkWidget *window)\n");
printf(WFILE "{\n");
printf(WFILE "\tint x;\n");
printf(WFILE "\n");
printf(WFILE "\tfor(x=0;x<100;x++)\n");
printf(WFILE "\t{\n");
printf(WFILE "\t\tliste_valid[x]=0;\n");
printf(WFILE "\t}\n");
printf(WFILE "\n");

for($tile=0;$tile<$tileindex;$tile++)
{
	$tnum=$tile_num[$tile];
	$tfile=$tile_file[$tile];
	$tip=$tile_tiptext[$tile];
	$adj=$tile_adjtext[$tile];
	$adef=$default[$tile];
	$amin=$minimum[$tile];
	$amax=$maximum[$tile];
	if($tip eq "") {$tip="---";}
	if($adj eq "") {$tip="---";}
	
	printf(WFILE "\n\t//TILE $tnum ($tfile)\n");
	printf(WFILE "\tif(language == 0)\n");
	printf(WFILE "\t{\n");
	printf(WFILE "\t\tsprintf(tooltext[$tnum],\"$tip\");\n");
	printf(WFILE "\t\tsprintf(adjtext[$tnum],\"$adj\");\n");
	printf(WFILE "\t}\n");
	$q=1;
	while($q <= $max_lang)
	{
		printf(WFILE "\tif(language == $q)\n");
		printf(WFILE "\t{\n");
		printf(WFILE "\t\tsprintf(tooltext[$tnum],\"".$tile_ltxt[$tile][$q]."\");\n");
		printf(WFILE "\t\tsprintf(adjtext[$tnum],\"".$tile_atxt[$tile][$q]."\");\n");
		printf(WFILE "\t}\n");
		$q++;
	}

	printf(WFILE "\tliste_valid[$tnum]=1;\n");
	if (substr($tile_adjtext[$tile],0,1) ne "-")
	{
		printf(WFILE "\tadjustable[$tnum]=1;\n");
	}
	else
	{
		printf(WFILE "\tadjustable[$tnum]=0;\n");
	}
	printf(WFILE "\tdefault_adjust[$tnum]=$adef;\n");
	printf(WFILE "\tmin_adjust[$tnum]=$amin;\n");
	printf(WFILE "\tmax_adjust[$tnum]=$amax;\n\n");

	for($mode=0;$mode<3;$mode++)
	{
		printf(WFILE "\t//MODE $mode\n");
		for($index=0;$index<31;$index++)
		{
			if(($index==0) || (($index >= $minimum[$tile]) && ($index <= $maximum[$tile])))
			{
				$z1=sprintf("_%03d",$tile_num[$tile]);
				$z2=sprintf("_%01d",$mode);
				$z3=sprintf("_%02d",$index);
				$xname="tile$z1$z2$z3";
				printf(WFILE "\ttiles_pixdat[$tnum][$mode][$index]=gdk_pixmap_create_from_xpm_d( window-> window, &tiles_mask[$tnum][$mode][$index],\n");
				printf(WFILE "\t\t&wstyle->bg[GTK_STATE_NORMAL],(gchar **)$xname);\n");
				if(mode == 0)
				{
					#tiledaten in Array schreiben???
				}
			}
		}
	}
	printf(WFILE "\n");
}

printf(WFILE "}\n");
close(WFILE);

open(WFILE,">../src/load_pixmaps40.c");

for($tile=0;$tile<$tileindex;$tile++)
{
	for($mode=0;$mode<3;$mode++)
	{
		for($index=0;$index<31;$index++)
		{
			if(($index==0) || (($index >= $minimum[$tile]) && ($index <= $maximum[$tile])))
			{
				$z1=sprintf("_%03d",$tile_num[$tile]);
				$z2=sprintf("_%01d",$mode);
				$z3=sprintf("_%02d",$index);
				$filename="#include \"../pixmaps/tiles40/tile$z1$z2$z3.xpm\"";
				printf(WFILE "%s\n",$filename);
			}
		}
	}
}

printf(WFILE "\n");
printf(WFILE "\n");
printf(WFILE "void load_pixmaps(GtkWidget *window)\n");
printf(WFILE "{\n");
printf(WFILE "\tint x;\n");
printf(WFILE "\n");
printf(WFILE "\tfor(x=0;x<100;x++)\n");
printf(WFILE "\t{\n");
printf(WFILE "\t\tliste_valid[x]=0;\n");
printf(WFILE "\t}\n");
printf(WFILE "\n");

for($tile=0;$tile<$tileindex;$tile++)
{
	$tnum=$tile_num[$tile];
	$tfile=$tile_file[$tile];
	$tip=$tile_tiptext[$tile];
	$adj=$tile_adjtext[$tile];
	$adef=$default[$tile];
	$amin=$minimum[$tile];
	$amax=$maximum[$tile];
	if($tip eq "") {$tip="---";}
	if($adj eq "") {$tip="---";}
	printf(WFILE "\n\t//TILE $tnum ($tfile)\n");
	printf(WFILE "\tif(language == 0)\n");
	printf(WFILE "\t{\n");
	printf(WFILE "\t\tsprintf(tooltext[$tnum],\"$tip\");\n");
	printf(WFILE "\t\tsprintf(adjtext[$tnum],\"$adj\");\n");
	printf(WFILE "\t}\n");
	$q=1;
	while($q <= $max_lang)
	{
		printf(WFILE "\tif(language == $q)\n");
		printf(WFILE "\t{\n");
		printf(WFILE "\t\tsprintf(tooltext[$tnum],\"".$tile_ltxt[$tile][$q]."\");\n");
		printf(WFILE "\t\tsprintf(adjtext[$tnum],\"".$tile_atxt[$tile][$q]."\");\n");
		printf(WFILE "\t}\n");
		$q++;
	}

	printf(WFILE "\tliste_valid[$tnum]=1;\n");
	if (substr($tile_adjtext[$tile],0,1) ne "-")
	{
		printf(WFILE "\tadjustable[$tnum]=1;\n");
	}
	else
	{
		printf(WFILE "\tadjustable[$tnum]=0;\n");
	}
	printf(WFILE "\tdefault_adjust[$tnum]=$adef;\n");
	printf(WFILE "\tmin_adjust[$tnum]=$amin;\n");
	printf(WFILE "\tmax_adjust[$tnum]=$amax;\n\n");

	for($mode=0;$mode<3;$mode++)
	{
		printf(WFILE "\t//MODE $mode\n");
		for($index=0;$index<31;$index++)
		{
			if(($index==0) || (($index >= $minimum[$tile]) && ($index <= $maximum[$tile])))
			{
				$z1=sprintf("_%03d",$tile_num[$tile]);
				$z2=sprintf("_%01d",$mode);
				$z3=sprintf("_%02d",$index);
				$xname="tile$z1$z2$z3";
				printf(WFILE "\ttiles_pixdat[$tnum][$mode][$index]=gdk_pixmap_create_from_xpm_d( window-> window, &tiles_mask[$tnum][$mode][$index],\n");
				printf(WFILE "\t\t&wstyle->bg[GTK_STATE_NORMAL],(gchar **)$xname);\n");
				if(mode == 0)
				{
					#tiledaten in Array schreiben???
				}
			}
		}
	}
	printf(WFILE "\n");
}

printf(WFILE "}\n");
close(WFILE);

sub pixline
{
	$ldat = $_[0];

	printf(WFILE "%s\n",$ldat);
	if($mode == 0)
	{
		for($plx=1;$plx<61;$plx++)
		{
			$ci=0;
			for($plc=0;$plc<70;$plc++)
			{
				if(substr($ldat,$plx,1) eq $pc[$plc])
				{
					$ci=$plc;
				}
			}
			printf(DFILE "0x%02X,",$ci);
			if(($plx % 20) == 0)
			{
				printf(DFILE "\n");
			}
		}
	}
}

