//################################################################################
//#                                                                              #
//# (c)2012-2013 Joerg Wolfram   joerg@jcwolfram.de                              #
//#                                                                              #
//# Dieses Programm ist freie Software. Sie können es unter den Bedingungen      #
//# der GNU General Public License, wie von der Free Software Foundation         #
//# veröffentlicht, weitergeben und/oder modifizieren, entweder gemäß            #
//# Version 3 der Lizenz oder (nach Ihrer Option) jeder späteren Version.        #
//#                                                                              #
//# Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, dass es       #
//# Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, auch ohne die     #
//# implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN          #
//# BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License.      #
//#                                                                              #
//# Sie sollten ein Exemplar der GNU General Public License zusammen mit         #
//# diesem Programm erhalten haben. Falls nicht, schreiben Sie an die Free       #
//# Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110,    #
//# USA.                                                                         #
//#                                                                              #
//# Jede Nutzung der Software/Informationen nonkonform zur GPL oder außerhalb    #
//# des Geltungsbereiches der GPL ist untersagt!                                 #
//#                                                                              #
//################################################################################
#include "../pixmaps/empty_mini.xpm"
#include "lang_messages.h"
//------------------------------------------------------------------------------
// Stringvergleich fuer qsort
//------------------------------------------------------------------------------
int my_cmp(const void *p1, const void *p2)
{
        char **s1 = (char **)p1;
        char **s2 = (char **)p2;
        return strcasecmp(*s1, *s2);
}

//------------------------------------------------------------------------------
// output an error information
//------------------------------------------------------------------------------
void error_message(int err_num)
{
	gtk_pixmap_set(GTK_PIXMAP (adjust_pwid),tiles_pixdat[111][0][0],tiles_mask[111][0][0]);
	gtk_label_set_text(GTK_LABEL(adjust_info),label_text[err_num*LANGUAGES+language]);
	gtk_widget_hide(adjust_edit2); //edit-Feld ausblenden
	conn_element = 100;
	active_element = 101;
	is_error = 1;
}

void set_preview()
{
	gtk_label_set(GTK_LABEL(action_name),project_name);
	small_image();
	action_pixmap[7] = gdk_pixmap_create_from_xpm_d( 
	window->window,&action_mask[7],&wstyle->bg[GTK_STATE_NORMAL],(gchar **)temp_xpm );
	gtk_pixmap_set(GTK_PIXMAP(action_pixwid[7]),action_pixmap[7],action_mask[7]);
}

//------------------------------------------------------------------------------
//fileselector box für Datei laden
//------------------------------------------------------------------------------
void get_flist()
{
	int i,fnum,fx,pos,act_box;
	struct dirent *CurrentFile;
	DIR *Directory;
	gchar *dummy_dat[2][2]={{"dummy","#"},{"dummy","#"}};
	char filename_txt[1000];
	gtk_clist_clear(GTK_CLIST(action_clist));
	act_box=selected_box;
	selected_box=0;

	if ( (Directory = opendir(prjdir)) == NULL)
	{
		error_message(ERROR_READ);
	}
	else
	{
		set_preview();
		backup_current();
		fnum = 0;
		fnames = 0;
		while ( (CurrentFile = readdir(Directory)) != NULL)
		{
			if (strcmp(CurrentFile->d_name,".") && strcmp(CurrentFile->d_name,".."))
			{
				if(fnames < 199)
				{
					strcpy(fname[fnames],CurrentFile->d_name);
					fnames++;
				}
			}
		}
		if(fnames > 0)
		{
			qsort(&fname[0], fnames, sizeof *fname, my_cmp);
			for(fx=0;fx<fnames;fx++)
			{
//				printf("N: %d = %s\n",fx,fname[fx]);
				sprintf(sfile,"%s/%s",prjdir,fname[fx]);
				if(fnum == 0)
				{
					strcpy(filename,sfile);
				}
				datei = fopen(sfile,"r");
				i=load_data();
				fclose (datei);
				if(i == 0)
				{
					load_field(0);	//redraw the field
					small_image();
					gtk_clist_append(GTK_CLIST(action_clist),dummy_dat[0]);
					strcpy(filename_txt,fname[fx]);
					for(pos=0;pos<strlen(filename_txt);pos++)
					{
						if(filename_txt[pos] == '.') filename_txt[pos] = 0;
					}
					gtk_clist_set_text(GTK_CLIST(action_clist),fnum,1,filename_txt);
					action_pixmap[8] = gdk_pixmap_create_from_xpm_d( 
					window->window,&action_mask[8],&wstyle->bg[GTK_STATE_NORMAL],(gchar **)temp_xpm );
					gtk_clist_set_pixmap(GTK_CLIST(action_clist),fnum,0,action_pixmap[8],action_mask[8]);
					fnum++;
				}
			}
		}
		selected_box=act_box;
		restore_current();
		action_entry=0;
		gtk_widget_hide(tree_win);
		gtk_widget_hide(work_area);
		gtk_widget_show(action_widget);
		gtk_widget_grab_focus(action_button[0]);
		load_field(selected_box);	//redraw the field
		transfer_active = 1;
	}
}



//------------------------------------------------------------------------------
// Selector box for programs
//------------------------------------------------------------------------------
void get_plist()
{
	int prg,j,act_box;
	char pname[40];
	gchar *dummy_dat[2][2]={{"dummy","#"},{"dummy","#"}};
	act_box=selected_box;
	selected_box=0;

	gtk_clist_clear(GTK_CLIST(action_clist));
	set_preview();
	backup_current();

	for(prg=0;prg<4;prg++)
	{
		for(j=0;j<31;j++)
		{
			pname[j]=memdat[0x200+j+0x400*prg];
		}
		pname[31]=0;
		readout_data(prg);
		load_field(0);	//redraw the field
		small_image();

		gtk_clist_append(GTK_CLIST(action_clist),dummy_dat[0]);
		gtk_clist_set_text(GTK_CLIST(action_clist),prg,1,pname);
		action_pixmap[8] = gdk_pixmap_create_from_xpm_d( 
		window->window,&action_mask[8],&wstyle->bg[GTK_STATE_NORMAL],(gchar **)temp_xpm );
		gtk_pixmap_set(GTK_PIXMAP(action_pixwid[8]),action_pixmap[8],action_mask[8]);
		gtk_clist_set_pixmap(GTK_CLIST(action_clist),prg,0,action_pixmap[8],action_mask[8]);

	}
	selected_box=act_box;
	action_entry=active_program;
	gtk_clist_select_row(GTK_CLIST(action_clist),action_entry,0);
	restore_current();
	load_field(selected_box);	//redraw the field
	transfer_active = 1;
}




//------------------------------------------------------------------------------
// Ausgabe infobox
//------------------------------------------------------------------------------
void info_message(int info_num)
{
	int loops;
	if(info_num < 0)
	{
		gtk_label_set_text(GTK_LABEL(adjust_info),"");
		gtk_pixmap_set(GTK_PIXMAP (adjust_pwid),tiles_pixdat[0][0][0],tiles_mask[0][0][0]);
		is_error = 0;
	}
	else
	{
		switch(info_num)
		{
		case ACTION_LOAD:
			gtk_pixmap_set(GTK_PIXMAP (adjust_pwid),tiles_pixdat[113][0][0],tiles_mask[113][0][0]);
			break;

		case ACTION_DOWNLOAD:
			gtk_pixmap_set(GTK_PIXMAP (adjust_pwid),tiles_pixdat[114][0][0],tiles_mask[114][0][0]);
			break;

		case ACTION_UPLOAD:
			gtk_pixmap_set(GTK_PIXMAP (adjust_pwid),tiles_pixdat[115][0][0],tiles_mask[115][0][0]);
			break;

		case ACTION_NAME:
			gtk_pixmap_set(GTK_PIXMAP (adjust_pwid),tiles_pixdat[116][0][0],tiles_mask[116][0][0]);
			break;

		case ACTION_COMM:
			gtk_pixmap_set(GTK_PIXMAP (adjust_pwid),tiles_pixdat[69][0][0],tiles_mask[69][0][0]);
			break;

		case INFO_CONNECT:
			gtk_pixmap_set(GTK_PIXMAP (adjust_pwid),tiles_pixdat[117][0][0],tiles_mask[117][0][0]);
			break;

		default:
			gtk_pixmap_set(GTK_PIXMAP (adjust_pwid),tiles_pixdat[112][0][0],tiles_mask[112][0][0]);
		}
		gtk_label_set_text(GTK_LABEL(adjust_info),label_text[info_num*LANGUAGES+language]);
		is_error = 1;
	}
	gtk_widget_hide(adjust_edit2); //edit-Feld ausblenden
	for(loops=0;loops<10;loops++)
	{
		gtk_main_iteration_do(FALSE);
	}
}

//------------------------------------------------------------------------------
// ASK NO
//------------------------------------------------------------------------------
void do_no( GtkWidget *widget,gpointer   data )
{
	if(ask_type != 4)
	{
		gtk_widget_show(work_area);
		gtk_widget_show(tree_win);
		gtk_widget_hide(action_widget);
		gtk_widget_hide(action_scrollwin);
	}
	transfer_active = 0;
	info_message(-1);
	conn_element = 100;
	active_element = 100;
	gtk_pixmap_set(GTK_PIXMAP (adjust_pwid),tiles_pixdat[0][0][0],tiles_mask[0][0][0]);
	gtk_widget_hide(action_alignment[9]); //example-button ausblenden
	gtk_widget_hide(action_alignment[10]); //prepare-button ausblenden
	gtk_widget_show(adjust_bwid);
	load_field(selected_box);	//redraw the field
	if(connect_ids[30] != 0)
	{
		gtk_signal_disconnect(GTK_OBJECT (tb_wid[30]),connect_ids[30]);
		connect_ids[30]=0;
	}
	if(connect_ids[31] != 0)
	{
		gtk_signal_disconnect(GTK_OBJECT (tb_wid[31]),connect_ids[31]);
		connect_ids[31]=0;
	}
}

//------------------------------------------------------------------------------
// ASK YES
//------------------------------------------------------------------------------
void do_yes( GtkWidget *widget,gpointer   data )
{
	char cmd[500];
	int i;
	info_message(-1);
	transfer_active = 0;
	load_field(selected_box);	//redraw the field
	gtk_widget_show(adjust_bwid);
	if(ask_type == 1)	//Exit
	{
		gtk_main_quit();
	}
	if(ask_type == 2)	//New
	{
		for(i=0;i<5;i++)
		{
			init_elements(i);
		}
		selected_box=0;
		is_error=0;
		conn_element=99;
		active_element=99;
		load_field(selected_box);
		gtk_pixmap_set(GTK_PIXMAP (adjust_pwid),tiles_pixdat[0][0][0],tiles_mask[0][0][0]);
		gtk_widget_hide(adjust_edit2); //edit-Feld ausblenden
		gtk_widget_hide(action_alignment[9]); //example-button ausblenden
		gtk_widget_hide(action_alignment[10]); //prepare-button ausblenden
		gtk_label_set_text(GTK_LABEL(adjust_info),"Neues Projekt");
		sprintf(project_name,"neu");
		sprintf(wtitle,"%s - LBlocks (Version %d.%02d)",project_name,VERSION,SVERSION);
		gtk_window_set_title (GTK_WINDOW (window), wtitle);
		load_field(selected_box);	//redraw the field
	}
	if(ask_type == 3)	//Overwrite
	{
		datei = fopen(sfile,"w");
		if(datei == NULL) //Datei ist schon vorhanden
		{
			error_message(ERROR_SAVE);
		}
		else
		{
			save_data();
			fclose(datei);
			info_message(INFO_SAVED);
		}
		load_field(selected_box);	//redraw the field
	}
	if(ask_type == 4)	//DELETE
	{
		load_field(selected_box);	//redraw the field
//		printf("DELx= %d\n",flist_entry);
		sprintf(cmd,"rm -f %s/%s",prjdir,fname[action_entry]);
		if(fnames > 1)
		{
			if(action_entry > 0)
			{
				gtk_clist_unselect_row(GTK_CLIST(action_clist),action_entry,0);
				gtk_clist_select_row(GTK_CLIST(action_clist),action_entry-1,0);
			}
			gtk_clist_remove(GTK_CLIST(action_clist),action_entry);
//			printf("DEL = %s\n",cmd);
			i=system(cmd);
			if(i != 0)
			{
				error_message(ERROR_DELETE);
			}
			get_flist();
		}
	}
	if(ask_type == 5)	//INSTALL EXAMPLES
	{
		is_error=0;
		load_field(selected_box);	//redraw the field
		i=copy_examples();
		if(i != 0) error_message(24);
		load_field(selected_box);	//redraw the field
		gtk_widget_hide(tb_wid[21]);
		gtk_widget_show(work_area);
	}
	if(ask_type == 6)	//PREPARE CONTROLLER
	{
		is_error=0;
		info_message(INFO_CONNECT);
//		gtk_widget_hide(adjust_edit2); //edit-Feld ausblenden
		if(mcu_type == 8)
		{
			sprintf(cmd,"%s/lblocks/scripts/fusescript_m8.sh",homedir);
		}
		else
		{
			sprintf(cmd,"%s/lblocks/scripts/fusescript_m88.sh",homedir);
		}
		i=system(cmd);
		gtk_widget_hide(tb_wid[21]);
		gtk_widget_show(work_area);
		if(i != 0) error_message(26); else info_message(27);
		load_field(selected_box);	//redraw the field
	}
	ask_type=0;
	if(connect_ids[30] != 0)
	{
		gtk_signal_disconnect(GTK_OBJECT (tb_wid[30]),connect_ids[30]);
		connect_ids[30]=0;
	}
	if(connect_ids[31] != 0)
	{
		gtk_signal_disconnect(GTK_OBJECT (tb_wid[31]),connect_ids[31]);
		connect_ids[31]=0;
	}
}

//------------------------------------------------------------------------------
// Ausgabe Fehlerbox
//------------------------------------------------------------------------------
void question(int qnum)
{
	connect_ids[30] = gtk_signal_connect_object (GTK_OBJECT (tb_wid[30]), "clicked",GTK_SIGNAL_FUNC (do_yes),NULL);
	connect_ids[31] = gtk_signal_connect_object (GTK_OBJECT (tb_wid[31]), "clicked",GTK_SIGNAL_FUNC (do_no),NULL);
	gtk_widget_hide(tb_wid[21]);
	gtk_widget_show(work_area);
	gtk_widget_show(tree_win);
	gtk_widget_hide(action_alignment[9]); //example-button ausblenden
	gtk_widget_hide(action_alignment[10]); //prepare-button ausblenden
	gtk_pixmap_set(GTK_PIXMAP (adjust_pwid),tiles_pixdat[110][0][0],tiles_mask[110][0][0]);
	gtk_label_set_text(GTK_LABEL(adjust_info),label_text[qnum*LANGUAGES+language]);
	transfer_active = 1;
	is_error = 2;
	load_field(selected_box);	//redraw the field
}

void question3(int qnum)
{
	connect_ids[30] = gtk_signal_connect_object (GTK_OBJECT (tb_wid[30]), "clicked",GTK_SIGNAL_FUNC (do_yes),NULL);
	connect_ids[31] = gtk_signal_connect_object (GTK_OBJECT (tb_wid[31]), "clicked",GTK_SIGNAL_FUNC (do_no),NULL);
	gtk_widget_hide(work_area);
	gtk_widget_show(tree_win);
	gtk_widget_hide(action_alignment[9]); //example-button ausblenden
	gtk_widget_hide(action_alignment[10]); //prepare-button ausblenden
	gtk_pixmap_set(GTK_PIXMAP (adjust_pwid),tiles_pixdat[110][0][0],tiles_mask[110][0][0]);
	gtk_label_set_text(GTK_LABEL(adjust_info),label_text[qnum*LANGUAGES+language]);
	transfer_active = 0;
	is_error = 2;
	load_field(selected_box);	//redraw the field
}



//------------------------------------------------------------------------------
// Ausgabe Fehlerbox
//------------------------------------------------------------------------------
void question2(int qnum)
{
	gtk_pixmap_set(GTK_PIXMAP (adjust_pwid),tiles_pixdat[110][0][0],tiles_mask[110][0][0]);
	gtk_label_set_text(GTK_LABEL(adjust_info),label_text[qnum*LANGUAGES+language]);
	transfer_active = 1;
	is_error = 2;
	load_field(selected_box);	//redraw the field
}

//------------------------------------------------------------------------------
// Intro-Screen ein- und ausblenden
//------------------------------------------------------------------------------
void intro_end( GtkWidget *widget,gpointer   data )
{
	gtk_widget_hide(tb_wid[21]);
	gtk_widget_show(work_area);
	gtk_label_set_text(GTK_LABEL(adjust_info),"");
	gtk_pixmap_set(GTK_PIXMAP (adjust_pwid),tiles_pixdat[0][0][0],tiles_mask[0][0][0]);
	gtk_widget_set_usize(adjust_box,SIZE_TILE * 14,SIZE_TILE + 1);
	gtk_widget_hide(action_alignment[9]); //example-button ausblenden
	gtk_widget_hide(action_alignment[10]); //prepare-button ausblenden
	gtk_widget_show(adjust_bwid);
	transfer_active = 0;
	load_field(selected_box);	//redraw the field
}

void intro_show( GtkWidget *widget,gpointer   data )
{
	if(transfer_active == 0)
	{
		gtk_widget_hide(work_area);
		gtk_widget_show(tb_wid[21]);
		info_message(INFO_LICENSE);
		gtk_widget_show(action_alignment[9]); //example-button ausblenden
		gtk_widget_show(action_alignment[10]); //prepare-button ausblenden
		gtk_widget_hide(adjust_bwid);
		action_set_mode(5);
		transfer_active = 1;
	}
}

//------------------------------------------------------------------------------
//ADJUST - Button
//------------------------------------------------------------------------------
void decrement_value( GtkWidget *widget,gpointer   data )
{
	int type,val;
	if(debug_callbacks == 1) g_print ("--- decrement\n");
	type=elements[selected_box][active_element][1];
	val=elements[selected_box][active_element][2];
	if(val > min_adjust[type])
	{
		val--;
		elements[selected_box][active_element][2] = val;
		load_field(selected_box);
	}
}

//------------------------------------------------------------------------------
//ADJUST + Button
//------------------------------------------------------------------------------
void increment_value( GtkWidget *widget,gpointer   data )
{
	int type,val;
	if(debug_callbacks == 1) g_print ("--- decrement\n");
	type=elements[selected_box][active_element][1];
	val=elements[selected_box][active_element][2];
	if(val < max_adjust[type])
	{
		val++;
		elements[selected_box][active_element][2] = val;
		load_field(selected_box);
	}
}




void hello( GtkWidget *widget,
            gpointer   data )
{
    g_print("Hello World\n");
}

gint delete_event( GtkWidget *widget,
                   GdkEvent  *event,
                   gpointer   data )
{

//    g_print("delete event occurred\n");
//    gtk_main_quit();
    return(TRUE);
}

void destroy( GtkWidget *widget,
              gpointer   data )
{
//    gtk_main_quit();
}

//------------------------------------------------------------------------------
// ask to clear sll
//------------------------------------------------------------------------------
void clear_all( GtkWidget *widget, gpointer data)
{
	ask_type=2;
	if(transfer_active == 0)
	{
		question(ASK_CLEAR);
		gtk_widget_grab_focus(tb_wid[31]);
	}
}

//------------------------------------------------------------------------------
// ask for exit
//------------------------------------------------------------------------------
void exit_prg( GtkWidget *widget, gpointer data)
{
	if(transfer_active == 0)
	{
		ask_type=1;
		question(ASK_EXIT);
		gtk_widget_grab_focus(tb_wid[31]);
		transfer_active = 1;
	}
}

//------------------------------------------------------------------------------
// install examples
//------------------------------------------------------------------------------
void install_examples( GtkWidget *widget, gpointer data)
{
//	if(transfer_active == 0)
	{
		ask_type=5;
		gtk_widget_show(adjust_bwid);
		question3(ASK_INSTALL);
		gtk_widget_grab_focus(tb_wid[31]);
		transfer_active = 0;
	}
}

//------------------------------------------------------------------------------
// install examples
//------------------------------------------------------------------------------
void prepare_chip( GtkWidget *widget, gpointer data)
{
//	if(transfer_active == 0)
	{
		ask_type=6;
		gtk_widget_show(adjust_bwid);
		question3(ASK_PREPARE);
		gtk_widget_grab_focus(tb_wid[31]);
		transfer_active = 0;
	}
}

//------------------------------------------------------------------------------
// Klick auf ein Listenelement
//------------------------------------------------------------------------------
void list_clicked( GtkWidget *widget, GdkEventButton *event,gpointer data)
{
	int type;
	if(debug_callbacks == 1) g_print("--- list clicked\n");

	if(transfer_active == 0)
	{
		//Daten des Feldes bestimmen
		type  = widget;
		gtk_pixmap_set(	GTK_PIXMAP (adjust_pwid),
				tiles_pixdat[type][0][0],
				tiles_mask[type][0][0]);
		gtk_label_set_text(GTK_LABEL(adjust_info),tooltext[type]);
		gtk_widget_hide(adjust_edit2);
		active_element = 104;
		conn_element = 101;
//		load_field(selected_box);
	}
}


//------------------------------------------------------------------------------
// Klick auf ein Feldelement
//------------------------------------------------------------------------------
void field_clicked( GtkWidget *widget, GdkEventButton *event,gpointer data)
{
	div_t xy;
	int z,type;
	int fcoord,conn_ok;
	if(debug_callbacks == 1) g_print("--- field clicked\n");

	fcoord=widget;

	//Daten des Feldes bestimmen
	type=field[fcoord];
	xy=div(fcoord,12);

	//zum zweiten mal auf das gleiche Element geklickt

	if((find_element(fcoord) == active_element) && (transfer_active == 0))
	{
		conn_element = active_element;	//das bisherige aktive Element bekonnt conn status

		// Die Ausgänge (3,5) können kein Startblock sein
		if((elements[selected_box][conn_element][1] == 3)
		|| (elements[selected_box][conn_element][1] == 5))
		{
			conn_element = 100;
			error_message(ERROR_CBEG);
		}

		// Ein Element in der letzten Spalte kann kein Startblock sein
		if(xy.rem == 11)
		{
			conn_element = 100;
			error_message(ERROR_CBEG);
		}
		
		//testen, ob der Block schon Startblock einer Route ist
		for(z=0;z<32;z++)
		{
//			if(routes[selected_box][z][0] == fcoord) conn_element=100;
		}
		if(conn_element < 100) active_element = 100;
	}
	else

	//Nur ein Einfachklick
	{
		last_clicked=fcoord;

		//Element aktivieren
		if(conn_element > 31)
		{
			active_element = find_element(fcoord);
		}
		else
		//Verbindung ziehen
		{
			conn_ok = 1;

			active_element = find_element(fcoord);

			if(active_element == conn_element) 
			{
				conn_ok = 0;
			}

			// Die Eingänge (2,4) können kein Endblock sein
			if(((elements[selected_box][active_element][1] == 2)
			|| (elements[selected_box][active_element][1] == 4))
			&& (conn_ok == 1))
			{
				conn_ok = 0;
				error_message(ERROR_CEND);
			}

			//Block kann nicht gleichzeitig Anfang und Ende der Route sein
			
			//Blöcke in der ersten spalte können nicht connectiert werden
			if(xy.rem == 0) conn_ok = 0;

			//kann überhaupt geroutet werden?
			if(conn_ok == 1)
			{
				add_route(conn_element,active_element);
				conn_element = 255;
			}
			else
			{
				active_element = conn_element;
				conn_element = 255;
			}
		}
	}
	load_field(selected_box);
}

//------------------------------------------------------------------------------
// Drag von Liste speichert den Element-Prototypen im Drag-buffer
//------------------------------------------------------------------------------
void list_drag(
		GtkWidget *widget,
		GdkDragContext     *context,
		GtkSelectionData   *selection_data,
		guint               info,
		guint               time,
		gpointer            data)
{
	if(debug_callbacks == 1) g_print("--- list drag\n");
	drag_element = 300; //list element
	drag_type  = widget;
	drag_value = default_adjust[drag_type];

	gtk_drag_set_icon_pixmap(	context,
					gtk_widget_get_colormap(element_list),
					tiles_pixdat[drag_type][0][0],
					tiles_mask[drag_type][0][0],
					(SIZE_TILE / 2),(SIZE_TILE / 2));
}

//------------------------------------------------------------------------------
// Drag von Feld speichert die Felddaten im Drag-buffer
//------------------------------------------------------------------------------
void field_drag(
		GtkWidget *widget,
		GdkDragContext     *context,
		GtkSelectionData   *selection_data,
		guint               info,
		guint               time,
		gpointer            data)
{
	int position;

	position=widget;

	if(debug_callbacks == 1) g_print("--- field drag\n");
	drag_element = field[position];
	if(drag_element < 32) // drag element
	{
		drag_type = elements[selected_box][drag_element][1];
		drag_value = elements[selected_box][drag_element][2];

		gtk_drag_set_icon_pixmap(	context,
						gtk_widget_get_colormap(element_list),
						tiles_pixdat[drag_type][0][0],
						tiles_mask[drag_type][0][0],
						(SIZE_TILE / 2),(SIZE_TILE / 2));

//		g_print("drag element %d from %d\n",drag_element,position);
	}
	else //drag route part
	{
		drag_type = 0;
		drag_value = 0;
	}
}

//------------------------------------------------------------------------------
// Drop auf Feld setzt ein neues Element oder verschiebt ein vorhandenes
//------------------------------------------------------------------------------
void field_drop(GtkWidget *widget, GdkDragContext *context, guint time)
{
	int fld,position,element;
	position = 0;
	if(debug_callbacks == 1) g_print("--- field drop\n");

//	das betroffene widget bestimmen, keine optimale Löusung aber es geht
	for(fld=0;fld<96;fld++)
	{
		if(widget==field_bwid[fld])
		{
			position = fld;
		}
	}

	if(transfer_active == 0)
	{

		//Feld aus Liste
		if((drag_element == 300) && (field[position] == 255))
		{
			element=add_element(position,drag_type,drag_value);
			if(debug_callbacks == 1) g_print("add element = %d\n",element);
//			if(element < 32) active_element= element;
			active_element = 100;
		}

		//Feld verschieben
		if((drag_element < 32) && (field[position] == 255))
		{
			if(debug_callbacks == 1) g_print("move element %d to %d\n",drag_element,position);
			elements[selected_box][drag_element][0]=position;
//			active_element = drag_element;
			active_element = 100;
			delete_element_routes(drag_element);
		}
		load_field(selected_box);
		drag_element=99;
		last_clicked=255;
	}
}

//------------------------------------------------------------------------------
// Drop auf Liste löscht das ge-dragte Element
//------------------------------------------------------------------------------
void list_drop(GtkWidget *widget,GdkDragContext *context,guint time)
{
	if(debug_callbacks == 1) g_print("--- list drop\n");
	if(debug_callbacks == 1) g_print("DEL: %d\n",drag_element);

	if(transfer_active == 0)
	{
		//delete a field
		if(drag_element < 32)
		{
			if(elements[selected_box][drag_element][1] > 5)
			{
				delete_element(drag_element);
				delete_element_routes(drag_element);
			}
		}
		//delete a connection
		else if(drag_element < 64)
		{
			if(debug_callbacks == 1) g_print("DELROUTE: %d\n",drag_element-32);
			routes[selected_box][drag_element-32][0]=255;
			routes[selected_box][drag_element-32][1]=255;
			sort_routes();
			print_field();
		}
		load_field(selected_box);
		drag_element=99;
	}
}

//------------------------------------------------------------------------------
//Screenshot soll gespeichert werden
//------------------------------------------------------------------------------
void file_screenshot( GtkWidget *widget,gpointer   data )
{

	if(transfer_active == 0)
	{
		sprintf(sfile,"%s/lblocks/screenshot.png",homedir);
		datei = fopen(sfile,"wb");
		if(datei != NULL)
		{
			save_screenshot();
			info_message(INFO_SCREENSHOT);
			fclose(datei);
		}
	}
}

//------------------------------------------------------------------------------
//fileselector box für Datei laden
//------------------------------------------------------------------------------
void file_save( GtkWidget *widget,gpointer   data )
{
	if(transfer_active == 0)
	{
		sprintf(sfile,"%s/%s.lblocks",prjdir,project_name);
		datei = fopen(sfile,"r");
		if(datei != NULL) //Datei ist schon vorhanden
		{
			fclose (datei);
			ask_type=3;
			question(ASK_OVER);
			gtk_widget_grab_focus(tb_wid[31]);
		}
		else //Datei speichern
		{
			datei = fopen(sfile,"w");
			if(datei == NULL) //Datei ist schon vorhanden
			{
				error_message(ERROR_SAVE);
			}
			else
			{
				save_data();
				fclose(datei);
				info_message(INFO_SAVED);
			}
		}
	}
}

//------------------------------------------------------------------------------
//fileselector box für Datei laden
//------------------------------------------------------------------------------
void file_open( GtkWidget *widget,gpointer   data )
{
	if(transfer_active == 0)
	{
		get_flist();
		action_set_mode(1);
	}
}


void set_prog()
{
	if(active_program == 0)
	{
		gtk_pixmap_set(GTK_PIXMAP (tp_wid[22]),toolb[23],toolm[23]);
	}
	else
	{
		gtk_pixmap_set(GTK_PIXMAP (tp_wid[22]),toolb[22],toolm[22]);
	}
	if(active_program == 1)
	{
		gtk_pixmap_set(GTK_PIXMAP (tp_wid[24]),toolb[25],toolm[25]);
	}
	else
	{
		gtk_pixmap_set(GTK_PIXMAP (tp_wid[24]),toolb[24],toolm[24]);
	}
	if(active_program == 2)
	{
		gtk_pixmap_set(GTK_PIXMAP (tp_wid[26]),toolb[27],toolm[27]);
	}
	else
	{
		gtk_pixmap_set(GTK_PIXMAP (tp_wid[26]),toolb[26],toolm[26]);
	}
	if(active_program == 3)
	{
		gtk_pixmap_set(GTK_PIXMAP (tp_wid[28]),toolb[29],toolm[29]);
	}
	else
	{
		gtk_pixmap_set(GTK_PIXMAP (tp_wid[28]),toolb[28],toolm[28]);
	}
}

void prog_1( GtkWidget *widget,gpointer data)
{
	active_program = 0;
	set_prog();
}

void prog_2( GtkWidget *widget,gpointer data)
{
	active_program = 1;
	set_prog();
}

void prog_3( GtkWidget *widget,gpointer data)
{
	active_program = 2;
	set_prog();
}

void prog_4( GtkWidget *widget,gpointer data)
{
	active_program = 3;
	set_prog();
}



//------------------------------------------------------------------------------
// upload program to controller
//------------------------------------------------------------------------------
void proj_upload( GtkWidget *widget,gpointer   data )
{
	int x;

	if (transfer_active == 0)
	{
		info_message(INFO_CONNECT);
		conn_element = 100;
		active_element = 101;
		x=download();

		if((x > 0) && (1 == 1))
		{
			error_message(ERROR_CONNECT);
			g_print("Lesen-Errcode: %d\n",x);
		}
		else
		{
			get_plist();
			action_set_mode(3);
			transfer_active = 1;
		}
	}
}


//------------------------------------------------------------------------------
//fileselector box für Datei laden
//------------------------------------------------------------------------------
void proj_download( GtkWidget *widget,gpointer   data )
{
	int x;

	if (transfer_active == 0)
	{
		info_message(INFO_CONNECT);
		conn_element = 100;
		active_element = 101;
		x=download();
		if(x > 0) 
		{
			error_message(ERROR_CONNECT);
			g_print("Lesen-Errcode: %d\n",x);
		}
		else
		{
			get_plist();
			action_set_mode(4);
			transfer_active = 1;
		}
	}
}

//------------------------------------------------------------------------------
//fileselector box für Datei laden
//------------------------------------------------------------------------------
void proj_name( GtkWidget *widget,gpointer   data )
{
	if(transfer_active == 0)
	{
		gtk_widget_hide(work_area);
		gtk_widget_hide(tree_win);
		load_field(0);	//redraw the field
		set_preview();
		load_field(selected_box);	//redraw the field

		strcpy(keyboard_string,">");

		strcat(keyboard_string,project_name);
		keyboard_string_len=strlen(keyboard_string);
		strcat(keyboard_string,"<");
		gtk_label_set_text(GTK_LABEL(keyboard_text),keyboard_string);

		action_set_mode(2);
		transfer_active = 1;
		gtk_widget_grab_focus(action_button[0]);
	}
}
