//################################################################################
//#                                                                              #
//# (c)2012-2013 Joerg Wolfram   joerg@jcwolfram.de                              #
//#                                                                              #
//# Dieses Programm ist freie Software. Sie können es unter den Bedingungen      #
//# der GNU General Public License, wie von der Free Software Foundation         #
//# veröffentlicht, weitergeben und/oder modifizieren, entweder gemäß            #
//# Version 3 der Lizenz oder (nach Ihrer Option) jeder späteren Version.        #
//#                                                                              #
//# Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, dass es       #
//# Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, auch ohne die     #
//# implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN          #
//# BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License.      #
//#                                                                              #
//# Sie sollten ein Exemplar der GNU General Public License zusammen mit         #
//# diesem Programm erhalten haben. Falls nicht, schreiben Sie an die Free       #
//# Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110,    #
//# USA.                                                                         #
//#                                                                              #
//# Jede Nutzung der Software/Informationen nonkonform zur GPL oder außerhalb    #
//# des Geltungsbereiches der GPL ist untersagt!                                 #
//#                                                                              #
//################################################################################
#include "main.h"

static char *prog_prototype[]=
{
 "#LBlocks 3",
 "===========================",
 " Box NR POS TYP VAL CON NXT",
 "* 0  00  24  02  00  99  99",
 "===========================",
 " Box NR POS TYP VAL CON NXT",
 "* 1  00  36  04  00  00  01",
 "* 1  01  47  05  00  99  99",
 "===========================",
 " Box NR POS TYP VAL CON NXT",
 "* 2  00  36  04  00  00  01",
 "* 2  01  47  05  00  99  99",
 "===========================",
 " Box NR POS TYP VAL CON NXT",
 "* 3  00  36  04  00  00  01",
 "* 3  01  47  05  00  99  99",
 "===========================",
 " Box NR POS TYP VAL CON NXT",
 "* 4  00  36  04  00  00  01",
 "* 4  01  47  05  00  99  99",
 "#End"
};


static char *gtk1rc_prototype[]=
{
 "style \"bold\"",
 "{",
 " font = \"-urw-nimbus sans l-bold-r-normal-*-*-*-*-*-p-*-iso8859-1\"",
 "}",
 " ",
 "widget \"*GtkLabel\" style \"bold\"",
 "widget \"*GtkCList\" style \"bold\"",
 "#End"
};


int prototype_prog(char *prog)
{
	FILE *fh;
	int i=0;
	if(!(fh=fopen(prog,"w"))) return 1;
	while((strcmp(prog_prototype[i],"#End"))!=0)
	{
		fprintf(fh,"%s\n",prog_prototype[i++]);
	}
	fclose(fh);
	return 0;
}

int prototype_scripts(char *progscript,char *readscript,char *mcu)
{
	FILE *fh,*fg;
	int i=0;

	if(!(fg=fopen(progscript,"w"))) 
	{
		g_print ("Kann Programmierscript nicht speichern\n");
		return 1;
	}
	fprintf(fg,"#!/bin/bash\n");
	fprintf(fg,"avrdude -p %s -c usbasp -B 0.1 -v -V -U flash:w:%s/lblocks/lblocks.hex\n",mcu,homedir);
	fclose(fg);

	if(!(fh=fopen(readscript,"w")))
	{
		g_print ("Kann Auslesescript nicht speichern\n");
		return 1;
	}
	fprintf(fh,"#!/bin/bash\n");
	fprintf(fh,"avrdude -p %s -c usbasp -B 0.1 -v -V -U flash:r:%s/lblocks/lblocks_read.hex:i\n",mcu,homedir);
	fclose(fh);

	return 0;
}

int prototype_fusescript_m8(char *fusescript)
{
	FILE *fh,*fg;
	int i=0;

	if(!(fh=fopen(fusescript,"w")))
	{
		g_print ("Kann Fusescript nicht speichern\n");
		return 1;
	}
	fprintf(fh,"#!/bin/bash\n");
	fprintf(fh,"avrdude -p m8 -c usbasp -B 10 -v -V -U lfuse:w:0xe4:m\n");
	fprintf(fh,"avrdude -p m8 -c usbasp -B 10 -v -V -U hfuse:w:0xd1:m\n");
	fclose(fh);

	return 0;
}


int prototype_fusescript_m88(char *fusescript)
{
	FILE *fh,*fg;
	int i=0;

	if(!(fh=fopen(fusescript,"w")))
	{
		g_print ("Kann Fusescript nicht speichern\n");
		return 1;
	}
	fprintf(fh,"#!/bin/bash\n");
	fprintf(fh,"avrdude -p m8 -c usbasp -B 10 -v -V -U lfuse:w:0xe4:m\n");
	fprintf(fh,"avrdude -p m8 -c usbasp -B 10 -v -V -U hfuse:w:0xd1:m\n");
	fclose(fh);

	return 0;
}


int config_start()
{
	char		command[200];
	char		my_gtkrc[2000]="";
	char		progscript[MAXPATHLEN];
	char		readscript[MAXPATHLEN];
	char		fusescript[MAXPATHLEN];
	int i,l;
	l=0;
	homedir=getenv("HOME");
	user=getenv("USER");
	sprintf(gtkrc,"%s/lblocks/gtkrc2",homedir);
	sprintf(prjdir,"%s/lblocks/data",homedir);
	i=access(prjdir, R_OK);
	if(i!=0)
	{
		sprintf(command,"mkdir -p %s/lblocks/data",homedir);
		system(command);
		sprintf(command,"mkdir -p %s/lblocks/scripts",homedir);
		system(command);
	}

	sprintf(progscript,"%s/lblocks/scripts/progscript_m8.sh",homedir);
	sprintf(readscript,"%s/lblocks/scripts/readscript_m8.sh",homedir);
	sprintf(fusescript,"%s/lblocks/scripts/fusescript_m8.sh",homedir);
	i=(access(progscript, R_OK) || access(readscript, R_OK));
	if(i!=0)
	{
//		g_print("PROG = %s\n",progscript);
//		g_print("READ = %s\n",readscript);
		l+=prototype_scripts(progscript,readscript,"m8");
		l+=prototype_fusescript_m8(fusescript);
		sprintf(command,"chmod u+x %s/lblocks/scripts/*.sh",homedir);
		system(command);
	}
	sprintf(progscript,"%s/lblocks/scripts/progscript_m88.sh",homedir);
	sprintf(readscript,"%s/lblocks/scripts/readscript_m88.sh",homedir);
	sprintf(fusescript,"%s/lblocks/scripts/fusescript_m88.sh",homedir);
	i=(access(progscript, R_OK) || access(readscript, R_OK));
	if(i!=0)
	{
//		g_print("PROG = %s\n",progscript);
//		g_print("READ = %s\n",readscript);
		l+=prototype_scripts(progscript,readscript,"m88");
		l+=prototype_fusescript_m88(fusescript);
		sprintf(command,"chmod u+x %s/lblocks/scripts/*.sh",homedir);
		system(command);
	}

	//now set the gtk attributes via gtkrc
	i=0;
	while((strcmp(gtk1rc_prototype[i],"#End"))!=0)
	{
		strcat(my_gtkrc,gtk1rc_prototype[i++]);
	}
	gtk_rc_parse_string(my_gtkrc);

	//write empty program
	sprintf(gtkrc,"%s/lblocks/data/neu.lblocks",homedir);
	i=access(gtkrc, R_OK);
	if(i!=0)
	{
		l+=prototype_prog(gtkrc);
	}
	return i;
}
