//################################################################################
//#                                                                              #
//# (c)2012-2013 Joerg Wolfram   joerg@jcwolfram.de                              #
//#                                                                              #
//# Dieses Programm ist freie Software. Sie können es unter den Bedingungen      #
//# der GNU General Public License, wie von der Free Software Foundation         #
//# veröffentlicht, weitergeben und/oder modifizieren, entweder gemäß            #
//# Version 3 der Lizenz oder (nach Ihrer Option) jeder späteren Version.        #
//#                                                                              #
//# Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, dass es       #
//# Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, auch ohne die     #
//# implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN          #
//# BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License.      #
//#                                                                              #
//# Sie sollten ein Exemplar der GNU General Public License zusammen mit         #
//# diesem Programm erhalten haben. Falls nicht, schreiben Sie an die Free       #
//# Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110,    #
//# USA.                                                                         #
//#                                                                              #
//# Jede Nutzung der Software/Informationen nonkonform zur GPL oder außerhalb    #
//# des Geltungsbereiches der GPL ist untersagt!                                 #
//#                                                                              #
//################################################################################
#include "main.h"

#include "route.c"
#include "examples.c"

int main( int   argc, char *argv[] )
{
	int i,j;
	char		wtitle[MAXPATHLEN+19];

	debug_callbacks=0;
	debug_routing=0;
	debug_comm = 0;
	mcu_type = 8;		//default mcu is the ATMega8
	transfer_active = 1;
	active_program = 0;
	is_error = 0;

//	printf("ARGS=%d\n",argc);
	language = 0;

	if(argc > 1)
	{
		j=0;
		for(i=1;i<argc;i++)
		{
//			printf ("arg= %s\n",argv[i]);
			if(strcmp(argv[i],"--en") == 0)		language = 1;
			if(strcmp(argv[i],"--ro") == 0)		language = 2;
			if(strcmp(argv[i],"--m88") == 0)	mcu_type = 88;
		}
	}

	selected_box=0;
	active_element=100;	//no active element
	conn_element=100;	//no element for connection

	last_clicked=100;

	for(i=0;i<80;i++)
	{
		for(j=0;j<120;j++)
		{
			min_pix[i][j][0]=0;
			min_pix[i][j][1]=i;
			min_pix[i][j][2]=j;
		}
	}

	for(j=0;j<50;j++)
	{
		connect_ids[j]=0;
	}

	//init GTK system
	gtk_init(&argc, &argv);
	//init/read config
	i=config_start();

	temp_xpm = (char**)malloc(320*sizeof(char*));

	for(i=0;i<320;i++)
	{
		temp_xpm[i]=(char*) malloc (440*sizeof(char));
	}

	fname = (char**)malloc(200*sizeof(char*));

	for(i=0;i<200;i++)
	{
		fname[i]=(char*) malloc (256*sizeof(char));
	}

	//init the program field
	init_elements(0);
	init_elements(1);
	init_elements(2);
	init_elements(3);
	init_elements(4);

	sprintf(project_name,"neu");
	sprintf(wtitle,"%s - LBlocks(Version %d.%02d)",project_name,VERSION,SVERSION);

	//create the main window
	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	wstyle = gtk_widget_get_style( window );
	gtk_widget_set_usize (window, 14 * SIZE_TILE + 70, 10 * SIZE_TILE + 56);
	gtk_container_set_border_width (GTK_CONTAINER (window), 0);
	gtk_window_set_title (GTK_WINDOW (window), wtitle);
	gtk_widget_show (window);
	gtk_signal_connect (GTK_OBJECT (window), "delete_event",GTK_SIGNAL_FUNC (exit_prg), NULL);
	gtk_window_set_policy(GTK_WINDOW (window), FALSE,FALSE,TRUE);

	//the main vertical box [menu/buttons/button_box]
	main_box = gtk_vbox_new (FALSE, 0);

	//the buttons area
	button_box = gtk_hbox_new (FALSE, 0);

	//load action buttons
	load_action(window);

	//horizontal separator
	separator1 = gtk_hseparator_new ();
	separator2 = gtk_hseparator_new ();
	separator3 = gtk_hseparator_new ();

	//the main box
	work_box = gtk_hbox_new (FALSE, 0);

	//load all pixmaps into array
	load_pixmaps(window);

	load_adj_pixmaps(window);

	//the adjust area
	adjust_box = gtk_hbox_new (FALSE, 0);
	generate_yesno(window);
	create_adjust_tile(window);
	gtk_widget_set_usize (adjust_box, SIZE_TILE * 14, SIZE_TILE);

	//the list area
	element_list = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (element_list);
	tree_win = gtk_scrolled_window_new (NULL, NULL);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (tree_win),
                                  GTK_POLICY_AUTOMATIC,
                                  GTK_POLICY_ALWAYS);
	gtk_widget_set_usize (tree_win, SIZE_TILE * 2 + 55, SIZE_TILE * 8);
	gtk_widget_show (tree_win);

	generate_list(window);

	gtk_scrolled_window_add_with_viewport (GTK_SCROLLED_WINDOW (tree_win),element_list);


	//the work area
	work_area = gtk_table_new (8,12,TRUE);
	generate_field(GTK_TABLE(work_area));

	//now build the window
	generate_intro(window,work_area);

	//gtk_widget_show(work_area);
	gtk_widget_set_usize (work_area, SIZE_TILE * 12, SIZE_TILE * 8 - 1);

	//nname set field
	keyboard_widget = gtk_vbox_new (FALSE, 0);
	gtk_widget_set_usize (keyboard_widget, SIZE_TILE * 12, SIZE_TILE * 8);
	load_keyboard(window);

	gtk_box_pack_start (GTK_BOX (work_box), tree_win, FALSE, TRUE, 5);
	gtk_box_pack_start (GTK_BOX (work_box), work_area, FALSE, FALSE, 0);
	gtk_box_pack_start (GTK_BOX (work_box), tb_wid[21], FALSE, FALSE, 0);
#if SIZE_TILE == 40
	gtk_box_pack_start (GTK_BOX (work_box), action_widget, FALSE, FALSE, 0);
#endif
#if SIZE_TILE == 60
	gtk_box_pack_start (GTK_BOX (work_box), action_widget, FALSE, FALSE, 16);
#endif

	gtk_box_pack_start (GTK_BOX (work_box), keyboard_widget, FALSE, FALSE, 0);
	gtk_box_pack_start (GTK_BOX (work_box), action_scrollwin, FALSE, FALSE, 0);
	gtk_widget_show(work_box);


	//the status window
	status_box = gtk_hbox_new (FALSE, 0);
	generate_boxselect(window,status_box);
	gtk_widget_show (status_box);

	gtk_widget_show (main_box);
	gtk_widget_show (button_box);
	gtk_widget_show (adjust_box);
	gtk_widget_show (work_box);
	gtk_widget_show (separator1);
	gtk_widget_show (separator2);
	gtk_widget_show (separator3);


	//now build the window
	generate_toolbar(window,button_box);

	//pack the main box
	gtk_box_pack_start (GTK_BOX (main_box), button_box, FALSE, FALSE, 3);
	gtk_box_pack_start (GTK_BOX (main_box), separator1, FALSE, TRUE, 3);
	gtk_box_pack_start (GTK_BOX (main_box), adjust_box, FALSE, FALSE, 3);
	gtk_box_pack_start (GTK_BOX (main_box), separator2, FALSE, TRUE, 3);
	gtk_box_pack_start (GTK_BOX (main_box), work_box, FALSE, FALSE, 3);
	gtk_box_pack_start (GTK_BOX (main_box), separator3, FALSE, TRUE, 2);
	gtk_box_pack_start (GTK_BOX (main_box), status_box, FALSE, FALSE, 0);

	//now pack the main box into the window
	gtk_container_add (GTK_CONTAINER (window), main_box);

	load_field(selected_box);	//switch to main screen
	info_message(8);
	action_set_mode(5);
//	printf("TA=%d\n",transfer_active);

	gtk_main ();
	return(0);
}

