//################################################################################
//#                                                                              #
//# (c)2012-2013 Joerg Wolfram   joerg@jcwolfram.de                              #
//#                                                                              #
//# Dieses Programm ist freie Software. Sie können es unter den Bedingungen      #
//# der GNU General Public License, wie von der Free Software Foundation         #
//# veröffentlicht, weitergeben und/oder modifizieren, entweder gemäß            #
//# Version 3 der Lizenz oder (nach Ihrer Option) jeder späteren Version.        #
//#                                                                              #
//# Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, dass es       #
//# Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, auch ohne die     #
//# implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN          #
//# BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License.      #
//#                                                                              #
//# Sie sollten ein Exemplar der GNU General Public License zusammen mit         #
//# diesem Programm erhalten haben. Falls nicht, schreiben Sie an die Free       #
//# Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110,    #
//# USA.                                                                         #
//#                                                                              #
//# Jede Nutzung der Software/Informationen nonkonform zur GPL oder außerhalb    #
//# des Geltungsbereiches der GPL ist untersagt!                                 #
//#                                                                              #
//################################################################################
#include <gtk/gtk.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <dirent.h>
#include <sys/param.h>
#include <stdio.h>
#include <string.h>
#include <strings.h>
#include <stdlib.h>
#include <unistd.h>
#include <png.h>
#include <fcntl.h>
#include <termios.h>

#ifndef FALSE
  #define FALSE 0
#endif

#ifndef TRUE
  #define TRUE !FALSE
#endif

#define VERSION 3
#define SVERSION 16
#define LANGUAGES 3

int language;
int mcu_type;

//save screenshots
png_byte color_type;
png_byte bit_depth;
png_structp png_ptr;
png_infop info_ptr;
png_bytep * row_ptr;


char * homedir;

//main arrays

//element type arrays
char tooltext[120][100];
char adjtext[120][100];

int liste_valid[120];
int adjustable[120];
int default_adjust[120];
int min_adjust[120];
int max_adjust[120];

int last_clicked;

int debug_callbacks;
int debug_routing;
int debug_comm;
int active_element;
int conn_element;

//DND variables
int drag_element;
int drag_type;
int drag_value;

FILE *datei;
char sfile[1000];
char prj[100];
char wtitle[100];

int selected_box;
int added_route,route_error;


char project_name[100];
char project_name_backup[100];

gboolean have_drag;

GdkPixmap *toolb[40];
GdkBitmap *toolm[40];
GtkWidget *tp_wid[40];
GtkWidget *tb_wid[40];

GtkWidget *window;

int field_pm[96][3];
char filename[1000];


int transfer_active;
int active_program;
int is_error;
int ask_type;

unsigned char min_pix[96][144][3];
char **temp_xpm;

GtkStyle *wstyle;

char pfadname[MAXPATHLEN];
//int  images,a_videos,m_videos,subdirs,rows,cols,rcol;
//unsigned char obuf[1000];
FILE	*fp;
char *homedir,*user,gtkrc[MAXPATHLEN],prjdir[MAXPATHLEN];

GdkPixmap *tiles_pixdat[256][3][31];
GdkBitmap *tiles_mask[256][3][31];


GtkWidget *tree_win,*tool_win,*field_win,*separator1,*separator2,*separator3;
GtkWidget *button,*main_box,*button_box,*box3,*main_menu,*element_list,*tbb;
GtkWidget *work_box,*work_area,*status_text,*status_box;
GtkWidget *list_area,*list_window;

GdkPixmap *list_b[100];
GdkBitmap *list_m[100];
GtkWidget *list_pwid[100];
GtkWidget *list_bwid[100];
GtkWidget *list_pack[50];



GdkPixmap *num_b[100];
GdkBitmap *num_m[100];
GtkWidget *num_pwid[100];
GtkWidget *num_bwid[100];

GtkWidget *xf;

int dialog_result;


GtkWidget *filebox;

gboolean have_drag;

int upload(void);
int download(void);


GtkWidget *dwindow,*dtext,*d_no,*d_yes,*d_p1,*d_p2,*d_p3,*d_p4,*d_vbox;
GtkWidget *l_p1,*l_p2,*l_p3,*l_p4,*b_p1,*b_p2,*b_p3,*b_p4;
GSList *group;

//------------------------------------------------------------------------------
// program data
//------------------------------------------------------------------------------
unsigned char memdat[65536];
char pname1[36];
char pname2[36];
char pname3[36];
char pname4[36];
int routes[5][32][2];
int elements[5][32][3];

int routes_backup[5][32][2];
int elements_backup[5][32][3];
int field[96];


//------------------------------------------------------------------------------
// work-area
//------------------------------------------------------------------------------
GdkPixmap *field_b[96];
GdkBitmap *field_m[96];
GtkWidget *field_pwid[96];
GtkWidget *field_bwid[96];
GtkWidget *field_table[96];

//------------------------------------------------------------------------------
// action elements
//------------------------------------------------------------------------------
GdkPixmap *action_pixmap[30];
GdkBitmap *action_mask[30];
GtkWidget *action_pixwid[30];
GtkWidget *action_button[30];
GtkWidget *action_alignment[30];
GtkWidget *action_widget;
GtkWidget *action_action;
GtkWidget *action_scrollwin;
GtkWidget *action_clist;
GtkWidget *action_name;
GtkWidget *action_sep;
gint connect_ids[50];
int action_mode;
int action_entry;
int flist_entry;
int fnames;
char **fname;

//------------------------------------------------------------------------------
// virtual keyboard
//------------------------------------------------------------------------------
GdkPixmap *key_pixmap[80];
GdkBitmap *key_mask[80];
GtkWidget *key_pixwid[80];
GtkWidget *key_button[80];
GtkWidget *keyboard_row[5];
GtkWidget *keyboard_widget;
GtkWidget *keyboard_text;
GtkWidget *keyboard_sep;
int key_caps;
int keyboard_string_len;
char keyboard_string[100];



//------------------------------------------------------------------------------
// Value adjust
//------------------------------------------------------------------------------
GdkPixmap *adjust_b;
GdkBitmap *adjust_m;
GtkWidget *adjust_pwid;
GtkWidget *adjust_bwid;
GdkPixmap *adjust_pixdat[100];
GdkBitmap *adjust_mask[100];
GtkObject *val_adjust;
GtkWidget *adjust_bar;
GtkWidget *adjust_box;
GtkWidget *adjust_box,*adjust_info,*adjust_minus_pwid,*adjust_minus_bwid,*adjust_edit,*adjust_edit2,*adjust_ask;
GtkWidget *adjust_num_pwid,*adjust_num_bwid,*adjust_plus_pwid,*adjust_plus_bwid;

//------------------------------------------------------------------------------
// subroutines
//------------------------------------------------------------------------------
void generate_progbutton( GtkWidget *window);
void generate_toolbar(GtkWidget *window,GtkWidget *box);
void generate_table(GtkWidget *window);
void generate_tree(GtkWidget *window);
void generate_list(GtkWidget *window);
void load_flist(GtkWidget *window);
void create_adjust_tile(GtkWidget *window);
void generate_field(GtkTable *tab);
void generate_intro(GtkWidget *window, GtkWidget *box);
void generate_proglist(GtkWidget *window);
void generate_boxselect(GtkWidget *window, GtkWidget *box);
void load_keyboard(GtkWidget *window);
void load_pixmaps(GtkWidget *window);
void load_adj_pixmaps(GtkWidget *window);
void load_action(GtkWidget *window);
void generate_yesno(GtkWidget *window);
int prototype_gtkrc(char *gtkrc);
int prototype_config(char *config);
int read_config(char *config);
int write_config(char *config);
int config_start();
void get_serial(gpointer user_data,gint source, GdkInputCondition condition);
void init_display(void);
void redraw_display(void);
void redraw_stat(void);

void switch_box(int new_box);
void route_connection(int startfield,int endfield);

#include "subroutines.h"
#include "route.h"
#include "datagen.h"


//------------------------------------------------------------------------------
// callbacks
//------------------------------------------------------------------------------
void hello( GtkWidget *widget,gpointer data );

gint delete_event( GtkWidget *widget,GdkEvent  *event, gpointer   data );
void destroy( GtkWidget *widget, gpointer   data );
int check_files(char *entry);

void listdir(char pname[MAXPATHLEN]);
void listdir1(char pname[MAXPATHLEN]);

void file_save( GtkWidget *widget, gpointer data);
void file_open( GtkWidget *widget, gpointer data);
void proj_upload( GtkWidget *widget, gpointer data);
void proj_download( GtkWidget *widget, gpointer data);
void proj_name( GtkWidget *widget, gpointer data);
void install_examples( GtkWidget *widget, gpointer data);
void prepare_chip( GtkWidget *widget, gpointer data);
void file_screenshot( GtkWidget *widget, gpointer data);
void prog_1( GtkWidget *widget, gpointer data);
void prog_2( GtkWidget *widget, gpointer data);
void prog_3( GtkWidget *widget, gpointer data);
void prog_4( GtkWidget *widget, gpointer data);
void prog_upload( GtkWidget *widget, gpointer data);
void prog_upload2( GtkWidget *widget, gpointer data);
void prog_download( GtkWidget *widget, gpointer data);
void field_clicked( GtkWidget *widget, GdkEventButton *event,gpointer data);
void list_clicked( GtkWidget *widget, GdkEventButton *event,gpointer data);
void field_key( GtkWidget *widget, GdkEventKey *event,gpointer data);
void clear_all( GtkWidget *widget, gpointer data);
void exit_prg( GtkWidget *widget, gpointer data);
void increment_value( GtkWidget *widget, gpointer data);
void decrement_value( GtkWidget *widget, gpointer data);
void intro_end( GtkWidget *widget, gpointer data);
void intro_show( GtkWidget *widget, gpointer data);

void do_yes( GtkWidget *widget, gpointer data);
void do_no( GtkWidget *widget, gpointer data);
void info_message(int info_num);

void action_set_mode(int mode);

void list_drag(
		GtkWidget *widget,
		GdkDragContext     *context,
		GtkSelectionData   *selection_data,
		guint               info,
		guint               time,
		gpointer            data);

void field_drag(
		GtkWidget *widget,
		GdkDragContext     *context,
		GtkSelectionData   *selection_data,
		guint               info,
		guint               time,
		gpointer            data);

void field_drop(
		GtkWidget *widget,
		GdkDragContext     *context,
		guint               time);

void list_drop(
		GtkWidget *widget,
		GdkDragContext     *context,
		guint               time);


