//################################################################################
//#                                                                              #
//# (c)2012-2013 Joerg Wolfram   joerg@jcwolfram.de                              #
//#                                                                              #
//# Dieses Programm ist freie Software. Sie können es unter den Bedingungen      #
//# der GNU General Public License, wie von der Free Software Foundation         #
//# veröffentlicht, weitergeben und/oder modifizieren, entweder gemäß            #
//# Version 3 der Lizenz oder (nach Ihrer Option) jeder späteren Version.        #
//#                                                                              #
//# Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, dass es       #
//# Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, auch ohne die     #
//# implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN          #
//# BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License.      #
//#                                                                              #
//# Sie sollten ein Exemplar der GNU General Public License zusammen mit         #
//# diesem Programm erhalten haben. Falls nicht, schreiben Sie an die Free       #
//# Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110,    #
//# USA.                                                                         #
//#                                                                              #
//# Jede Nutzung der Software/Informationen nonkonform zur GPL oder außerhalb    #
//# des Geltungsbereiches der GPL ist untersagt!                                 #
//#                                                                              #
//################################################################################
void sort_routes()
{
	int z,wp,temp_s,temp_e;
	wp=0;

	//routes in internes Array einlesen
	for(z=0;z<32;z++)
	{
		temp_s = routes[selected_box][z][0];
		temp_e = routes[selected_box][z][1];
		routes[selected_box][z][0]=255;
		routes[selected_box][z][1]=255;

		if((temp_s < 255) && (temp_e < 255))
		{
			routes[selected_box][wp][0]=temp_s;
			routes[selected_box][wp][1]=temp_e;
			wp++;
		}
	}
}


//eine neue Route hinzufuegen
int add_route(int startfield, int endfield)
{
	int q,z;
	div_t sf,ef;
	q=100;
	sf=div(startfield,12);
	ef=div(startfield,12);
	if((sf.rem + 1) > ef.rem)
	{
		if(debug_routing > 0) g_print ("ADD Route %d to %d\n",startfield,endfield);
		for(z=0;z<32;z++)
		{
			if((routes[selected_box][z][0] == startfield) && (routes[selected_box][z][1] == endfield) && (q==100))
			{
				q=99;
				if(debug_routing > 0) g_print ("Doubled Route\n");
			}
			if((routes[selected_box][z][0] == 255) && (routes[selected_box][z][1] == 255) && (q==100))
			{
				routes[selected_box][z][0]=startfield;
				routes[selected_box][z][1]=endfield;
				q=z;
				if(debug_routing > 0) g_print ("ADDED Route %d\n",z);
			}
		}
		return q;
	}
	else
	{
		return 32;
		if(debug_routing > 0) g_print ("No Route necessary\n");
	}
}

//delete all routes for a given conn field
void delete_route(int position)
{
	int route;
	route = field[position]-32;
	
	if((route >=0) && (route <32))
	{
		routes[selected_box][route][0]=255;	//kill start
		routes[selected_box][route][1]=255;	//kill end
	}
	sort_routes();
}

//delete all routes for a given conn field
void delete_last_route()
{
	int z;
	z=31;
	do{
		if((routes[selected_box][z][0] < 255) || (routes[selected_box][z][1] < 255))
		{
			routes[selected_box][z][0]=255;	//kill start
			routes[selected_box][z][1]=255;	//kill end
			z=-1;
		}
		z--;
	} while (z >= 0);
}


//delete all routes for a given element field
void delete_element_routes(int element)
{
	int z;

	if(debug_routing > 0) g_print ("Delete Routes connected to E%d\n",element);
	for(z=0;z<32;z++)
	{
		if((routes[selected_box][z][0] ==  element) || (routes[selected_box][z][1] == element))
		{
			if(debug_routing > 0) g_print ("del Route %d to %d\n",
				routes[selected_box][z][0],routes[selected_box][z][1]);
			routes[selected_box][z][0]=255;	//kill start
			routes[selected_box][z][1]=255;	//kill end
		}
	}
	sort_routes();
}

//------------------------------------------------------------------------------
// senkrechte Verbindung testen
//------------------------------------------------------------------------------
int y_connectable(int x, int y1, int y2)
{
	int y;
	if(y1 == y2)
	{
		if (field[x+12*y1] < 255) return 0;		//blockiert
	}
	else if (y1 < y2)
	{
		for(y=y1;y<=y2;y++)
		{
			if (field[x+12*y] < 255) return 0;	//blockiert
		}
	}
	else
	{
		for(y=y2;y<=y1;y++)
		{
			if (field[x+12*y] < 255) return 0;	//blockiert
		}
	}
	return 1; //PASS
}


//------------------------------------------------------------------------------
// waagerechte Verbindung testen
//------------------------------------------------------------------------------
int x_connectable(int y, int x1, int x2)
{
	int x;
	if(x1 == x2)
	{
		if (field[x1+12*y] < 255) return 0;		//blockiert
	}
	else if (x1 < x2)
	{
		for(x=x1;x<=x2;x++)
		{
			if (field[x+12*y] < 255) return 0;	//blockiert
		}
	}
	else
	{
		for(x=x2;x<=x1;x++)
		{
			if (field[x+12*y] < 255) return 0;	//blockiert
		}
	}
	return 1; //PASS
}

//------------------------------------------------------------------------------
//horizontale route gerade nach rechts mit Y1=Y2
//------------------------------------------------------------------------------
int check_route_horizontal1(int route,int x1,int y1, int x2, int y2)
{
	int dx,dy,x;
	dx=x2-x1;
	dy=y2-y1;
	if((dx > 1) && (dy==0))
	{
		if(x_connectable(y1,x1+1,x2-1) == 0) return 0;
		if(debug_routing > 0) g_print ("horizontal1\n");

		//route zeichnen
		for(x=x1+1;x<x2;x++)
		{
			field[x+12*y1]=route+32;
			view_route_element(x+12*y1,100);
		}
		return 1;
	}
	else
	{
		return 0;
	}
}

//------------------------------------------------------------------------------
//horizontale route nach rechts mit Y1<>Y2
//------------------------------------------------------------------------------
int check_route_horizontal2(int route,int x1,int y1, int x2, int y2)
{
	div_t mitte;
	int dx,dy,x,y,x_mitte;
	int route_found=0;
	dx=x2-x1;
	dy=y2-y1;
	mitte=div((x1+x2),2);
	x_mitte = mitte.quot;
	if(debug_routing > 0) g_print ("H2 %d  %d\n",dx,dy);
	if((dx > 1) && (dy != 0))
	{
		x=x_mitte;
		if((x_connectable(y1,x1+1,x) + x_connectable(y2,x,x2-1) + y_connectable(x,y1,y2)) < 3) 
		{
			if(debug_routing > 0) g_print ("<3\n");
			dx=1;
			while((route_found == 0) && (dx < 6))
			{
				x=x_mitte+dx;
				if((x > x1) && (x < x2))
				{
					if((x_connectable(y1,x1+1,x) + x_connectable(y2,x,x2-1) + y_connectable(x,y1,y2)) == 3) 
						route_found=1;
				}
				else
				{
					x=x_mitte-dx;
					if((x > x1) && (x < x2) && (route_found == 0))
					{
						if((x_connectable(y1,x1+1,x) + x_connectable(y2,x,x2-1) + y_connectable(x,y1,y2)) == 3) 
							route_found=1;
					}
				}
				dx++;
			}
		}
		else
		{
			route_found = 1;
		}
		if(route_found == 0) return 0;
		if(debug_routing > 0) g_print ("horizontal2\n");

		x_mitte=x;
		//zeichnen
		x=x1+1;
		y=y1;
		while(x < x_mitte)
		{
			field[x+12*y]=route+32;
			view_route_element(x+12*y,100);
			x++;
		}

		if(y1 < y2)
		{
			field[x+12*y]=route+32;	//erstes Eckfeld
			view_route_element(x+12*y,103);
			y++;
			while(y < y2)
			{
				field[x+12*y]=route+32;		//senkrecht
				view_route_element(x+12*y,101);
				y++;
			}
			field[x+12*y]=route+32;	//erstes Eckfeld
			view_route_element(x+12*y,104);
		}

		else
		{
			field[x+12*y]=route+32;	//erstes Eckfeld
			view_route_element(x+12*y,105);
			y--;
			while(y > y2)
			{
				field[x+12*y]=route+32;		//senkrecht
				view_route_element(x+12*y,101);
				y--;
			}
			field[x+12*y]=route+32;	//zweites Eckfeld
			view_route_element(x+12*y,102);
		}

		x++;

		while(x < x2)
		{
			field[x+12*y]=route+32;
			view_route_element(x+12*y,100);
			x++;
		}
		return 1;
	}
	else
	{
		return 0;
	}
}

//------------------------------------------------------------------------------
//horizontale route nach rechts mit sammler 6 als Zielpunkt
//der linke Eingang des Sammlers ist schon belegt
//------------------------------------------------------------------------------
int check_route_sammler6a(int route,int x1,int y1, int x2, int y2)
{
	int dx,dy,x,y,element;
	dx=x2-x1;
	dy=y2-y1;
	element = elements[selected_box][find_element(x2+12*y2)][1];
	if((dx > 0) && (dy > 0) && ((element == 6) || (element == 8)))
	{

		if(debug_routing > 0) g_print ("try sammler6a\n");

		if(x_connectable(y1,x1+1,x2) == 0) return 0;
		if(y_connectable(x2,y1,y2-1) == 0) return 0;

		if(debug_routing > 0) g_print ("sammler6a\n");

		//zeichnen
		x=x1+1;
		y=y1;
		while(x < x2)
		{
			field[x+12*y]=route+32;
			view_route_element(x+12*y,100);
			x++;
		}

		field[x+12*y]=route+32;
		view_route_element(x+12*y,103);
		y++;

		while(y < y2)
		{
			field[x+12*y]=route+32;
			view_route_element(x+12*y,101);
			y++;
		}
		return 1;
	}
	else
	{
		return 0;
	}
}

//------------------------------------------------------------------------------
//horizontale route nach rechts mit sammler 7 als Zielpunkt
//der linke Eingang des Sammlers ist schon belegt
//------------------------------------------------------------------------------
int check_route_sammler7a(int route,int x1,int y1, int x2, int y2)
{
	int dx,dy,x,y,element;
	dx=x2-x1;
	dy=y2-y1;
	element = elements[selected_box][find_element(x2+12*y2)][1];
	if((dx > 0) && (dy < 0) && ((element == 7) || (element == 8)))
	{
		if(x_connectable(y1,x1+1,x2) == 0) return 0;
		if(y_connectable(x2,y1,y2+1) == 0) return 0;

		if(debug_routing > 0) g_print ("sammler7a\n");

		//zeichnen
		x=x1+1;
		y=y1;
		while(x < x2)
		{
			field[x+12*y]=route+32;
			view_route_element(x+12*y,100);
			x++;
		}

		field[x+12*y]=route+32;
		view_route_element(x+12*y,105);
		y--;

		while(y > y2)
		{
			field[x+12*y]=route+32;
			view_route_element(x+12*y,101);
			y--;
		}
		return 1;
	}
	else
	{
		return 0;
	}
}

//------------------------------------------------------------------------------
//horizontale route nach links mit Y1<<Y2, dazwischen durchrouten
//------------------------------------------------------------------------------
int check_route_return1(int route,int x1,int y1, int x2, int y2)
{
	int dx,dy,x,y,y_mitte;
	int route_found=0;
	dx=x2-x1;
	dy=y2-y1;
	if((dx < 2) && (dy > 1))
	{
		y=y1+1;
		while((y <= (y2-1)) && (route_found == 0))
		{
			if ((y_connectable(x1+1,y1,y) + x_connectable(y,x1+1,x2-1) + y_connectable(x2-1,y,y2)) == 3) 
			{
				y_mitte = y;
				route_found = 1;
			}
			y++;
		}

		if(route_found == 0) return 0;

		if(debug_routing > 0) g_print ("return1\n");

		//route zeichnen
		//vom Startpunkt nach unten
		x=x1+1;
		y=y1;
		field[x+12*y]=route+32;
		view_route_element(x+12*y,103);
		y++;

		while(y < y_mitte)
		{
			field[x+12*y]=route+32;
			view_route_element(x+12*y,101);
			y++;
		}

		field[x+12*y]=route+32;
		view_route_element(x+12*y,105);
		x--;

		while(x >= x2)
		{
			field[x+12*y]=route+32;
			view_route_element(x+12*y,100);
			x--;
		}

		field[x+12*y]=route+32;
		view_route_element(x+12*y,102);
		y++;

		while(y < y2)
		{
			field[x+12*y]=route+32;
			view_route_element(x+12*y,101);
			y++;
		}

		field[x+12*y]=route+32;
		view_route_element(x+12*y,104);
		y++;
		return 1;
	}
	else
	{
		return 0;
	}
}

//------------------------------------------------------------------------------
//horizontale route nach links mit Y1>>Y2, dazwischen durchrouten
//------------------------------------------------------------------------------
int check_route_return2(int route,int x1,int y1, int x2, int y2)
{
	int dx,dy,x,y,y_mitte;
	int route_found=0;
	dx=x2-x1;
	dy=y2-y1;
	if((dx < 2) && (dy < -1))
	{
		y=y2+1;
		while((y <= (y1-1)) && (route_found == 0))
		{
			if ((y_connectable(x1+1,y1,y) + x_connectable(y,x1+1,x2-1) + y_connectable(x2-1,y,y2)) == 3) 
			{
				y_mitte = y;
				route_found = 1;
			}
			y++;
		}
		if(route_found == 0) return 0;

		if(debug_routing > 0) g_print ("return2\n");

		//route zeichnen
		//vom Startpunkt nach unten
		x=x1+1;
		y=y1;
		field[x+12*y]=route+32;
		view_route_element(x+12*y,105);
		y--;

		while(y > y_mitte)
		{
			field[x+12*y]=route+32;
			view_route_element(x+12*y,101);
			y--;
		}

		field[x+12*y]=route+32;
		view_route_element(x+12*y,103);
		x--;

		while(x >= x2)
		{
			field[x+12*y]=route+32;
			view_route_element(x+12*y,100);
			x--;
		}

		field[x+12*y]=route+32;
		view_route_element(x+12*y,104);
		y--;

		while(y > y2)
		{
			field[x+12*y]=route+32;
			view_route_element(x+12*y,101);
			y--;
		}

		field[x+12*y]=route+32;
		view_route_element(x+12*y,102);
		y--;
		return 1;
	}
	else
	{
		return 0;
	}
}
//------------------------------------------------------------------------------
//horizontale route nach links mit X1<X2, nach oben ausweichen
//------------------------------------------------------------------------------
int check_route_return3(int route,int x1,int y1, int x2, int y2)
{
	int dx,dy,x,y,y_mitte;
	int route_found=0;
	dx=x2-x1;
	dy=y2-y1;
	if((dx < 0) && (y1 > 0) && (y2 > 0))
	{
		y=y2-1;
		if((y1-1) < y) y=y1-1;
		while((y >= 0) && (route_found == 0))
		{
			if ((y_connectable(x1+1,y1,y) + x_connectable(y,x1+1,x2-1) + y_connectable(x2-1,y,y2)) == 3) 
			{
				y_mitte = y;
				route_found = 1;
			}
			y--;
		}
		if(route_found == 0) return 0;

		if(debug_routing > 0) g_print ("return3\n");

		//route zeichnen
		//vom Startpunkt nach oben
		x=x1+1;
		y=y1;
		field[x+12*y]=route+32;
		view_route_element(x+12*y,105);
		y--;

		while(y > y_mitte)
		{
			field[x+12*y]=route+32;
			view_route_element(x+12*y,101);
			y--;
		}

		field[x+12*y]=route+32;
		view_route_element(x+12*y,103);
		x--;

		while(x >= x2)
		{
			field[x+12*y]=route+32;
			view_route_element(x+12*y,100);
			x--;
		}

		field[x+12*y]=route+32;
		view_route_element(x+12*y,102);
		y++;

		while(y < (y2))
		{
			field[x+12*y]=route+32;
			view_route_element(x+12*y,101);
			y++;
		}

		field[x+12*y]=route+32;
		view_route_element(x+12*y,104);

		return 1;
	}
	else
	{
		return 0;
	}
}


//------------------------------------------------------------------------------
//horizontale route nach links mit Y1>>Y2, anti C (bogen aussen herum)
//------------------------------------------------------------------------------
int check_route_return3a(int route,int x1,int y1, int x2, int y2)
{
	int dx,dy,x,y,x_mitte,element;
	int route_found = 0;
	dx=x2-x1;
	dy=y2-y1;
	element = elements[selected_box][find_element(x2+12*y2)][1];
	if((dy < 0) && (element == 6) && (y2 > 0))
	{
		//minimales X  für den Bogen berechnen
		x=x1+1;
		if(x < x2) x=x2;
	
		while((x < 12) && (route_found == 0))
		{
			if ((x_connectable(y1,x1+1,x) + x_connectable(y2-1,x2,x) + y_connectable(x,y1,y2-1)) == 3) 
			{
				x_mitte = x;
				route_found = 1;
			}
			x++;
		}

		if(route_found == 0) return 0;
		
		if(debug_routing > 0) g_print ("anti-c\n");

		//route zeichnen
		//vom Startpunkt nach oben
		x=x1+1;
		y=y1;
		
		//nach rechts
		while(x < x_mitte)
		{
			field[x+12*y]=route+32;
			view_route_element(x+12*y,100);
			x++;
		}
		
		//rechte untere Ecke
		field[x+12*y]=route+32;
		view_route_element(x+12*y,105);
		y--;

		//linie nach oben
		while(y > (y2-1))
		{
			field[x+12*y]=route+32;
			view_route_element(x+12*y,101);
			y--;
		}

		//rechte obere Ecke
		field[x+12*y]=route+32;
		view_route_element(x+12*y,103);
		x--;

		//linie nach links
		while(x > x2)
		{
			field[x+12*y]=route+32;
			view_route_element(x+12*y,100);
			x--;
		}

		//ecke links oben
		field[x+12*y]=route+32;
		view_route_element(x+12*y,102);
		y++;

		while(y < (y2-1))
		{
			field[x+12*y]=route+32;
			view_route_element(x+12*y,101);
			y++;
		}

		return 1;
	}
	else
	{
		return 0;
	}
}


//------------------------------------------------------------------------------
//horizontale route nach links mit Y1>>Y2, anti C (bogen aussen herum)
//------------------------------------------------------------------------------
int check_route_return3b(int route,int x1,int y1, int x2, int y2)
{
	int dx,dy,x,y,x_mitte,element;
	int route_found = 0;
	dx=x2-x1;
	dy=y2-y1;
	element = elements[selected_box][find_element(x2+12*y2)][1];
	if((dy < 0) && (element == 6) && (y2 > 1))
	{
		//minimales X  für den Bogen berechnen
		x=x1+1;
		if(x < x2) x=x2;
	
		while((x < 12) && (route_found == 0))
		{
			if ((x_connectable(y1,x1+1,x) + x_connectable(y2-2,x2,x) + y_connectable(x2,y2-2,y2-1) + 
				+ y_connectable(x,y1,y2-2)) == 4) 
			{
				x_mitte = x;
				route_found = 1;
			}
			x++;
		}

		if(route_found == 0) return 0;
		
		if(debug_routing > 0) g_print ("anti-c (2)\n");

		//route zeichnen
		//vom Startpunkt nach oben
		x=x1+1;
		y=y1;
		
		//nach rechts
		while(x < x_mitte)
		{
			field[x+12*y]=route+32;
			view_route_element(x+12*y,100);
			x++;
		}
		
		//rechte untere Ecke
		field[x+12*y]=route+32;
		view_route_element(x+12*y,105);
		y--;

		//linie nach oben
		while(y > (y2-2))
		{
			field[x+12*y]=route+32;
			view_route_element(x+12*y,101);
			y--;
		}

		//rechte obere Ecke
		field[x+12*y]=route+32;
		view_route_element(x+12*y,103);
		x--;

		//linie nach links
		while(x > x2)
		{
			field[x+12*y]=route+32;
			view_route_element(x+12*y,100);
			x--;
		}

		//ecke links oben
		field[x+12*y]=route+32;
		view_route_element(x+12*y,102);
		y++;

		while(y < (y2))
		{
			field[x+12*y]=route+32;
			view_route_element(x+12*y,101);
			y++;
		}

		return 1;
	}
	else
	{
		return 0;
	}
}


//------------------------------------------------------------------------------
//horizontale route nach links mit Y1<<Y2, nach unten ausweichen
//------------------------------------------------------------------------------
int check_route_return4(int route,int x1,int y1, int x2, int y2)
{
	int dx,dy,x,y,y_mitte;
	int route_found=0;
	dx=x2-x1;
	dy=y2-y1;
	if((dx < 0) && (y1 < 7) && (y2 < 7))
	{
		y=y2+1;
		if((y1+1) > y) y=y1+1;
		while((y < 8) && (route_found == 0))
		{
			if ((y_connectable(x1+1,y1,y) + x_connectable(y,x1+1,x2-1) + y_connectable(x2-1,y,y2)) == 3) 
			{
				y_mitte = y;
				route_found = 1;
			}
			y++;
		}
		if(route_found == 0) return 0;

		if(debug_routing > 0) g_print ("return4\n");

		//route zeichnen
		//vom Startpunkt nach oben
		x=x1+1;
		y=y1;
		field[x+12*y]=route+32;
		view_route_element(x+12*y,103);
		y++;

		while(y < y_mitte)
		{
			field[x+12*y]=route+32;
			view_route_element(x+12*y,101);
			y++;
		}

		field[x+12*y]=route+32;
		view_route_element(x+12*y,105);
		x--;

		while(x >= x2)
		{
			field[x+12*y]=route+32;
			view_route_element(x+12*y,100);
			x--;
		}

		field[x+12*y]=route+32;
		view_route_element(x+12*y,104);
		y--;

		while(y > y2)
		{
			field[x+12*y]=route+32;
			view_route_element(x+12*y,101);
			y--;
		}

		field[x+12*y]=route+32;
		view_route_element(x+12*y,102);

		return 1;
	}
	else
	{
		return 0;
	}
}



//------------------------------------------------------------------------------
//horizontale route nach links mit Y1<<Y2, dazwischen durchrouten
//------------------------------------------------------------------------------
int check_route_sammler6b(int route,int x1,int y1, int x2, int y2)
{
	int dx,dy,x,y,y_mitte,element;
	int route_found = 0;
	dx=x2-x1;
	dy=y2-y1;
	element = elements[selected_box][find_element(x2+12*y2)][1];
	if((dx < 0) && ((element == 6) || (element == 8)) && (y1 > 0) && (y2 > 0))
	{
		y=y2-1;
		if((y1-1) < y) y=y1-1;
		while((y >= 0) && (route_found == 0))
		{
			if ((y_connectable(x1+1,y1,y) + x_connectable(y,x1+1,x2) + y_connectable(x2,y,y2-1)) == 3) 
			{
				y_mitte = y;
				route_found = 1;
			}
			y--;
		}
		if(route_found == 0) return 0;

		if(debug_routing > 0) g_print ("sammler6b\n");

		//route zeichnen
		//vom Startpunkt nach oben
		x=x1+1;
		y=y1;
		field[x+12*y]=route+32;
		view_route_element(x+12*y,105);
		y--;

		while(y > y_mitte)
		{
			field[x+12*y]=route+32;
			view_route_element(x+12*y,101);
			y--;
		}

		field[x+12*y]=route+32;
		view_route_element(x+12*y,103);
		x--;

		while(x > x2)
		{
			field[x+12*y]=route+32;
			view_route_element(x+12*y,100);
			x--;
		}

		field[x+12*y]=route+32;
		view_route_element(x+12*y,102);
		y++;

		while(y < (y2))
		{
			field[x+12*y]=route+32;
			view_route_element(x+12*y,101);
			y++;
		}
		return 1;
	}
	else
	{
		return 0;
	}
}


//------------------------------------------------------------------------------
//horizontale route nach links mit Y1<<Y2, dazwischen durchrouten
//------------------------------------------------------------------------------
int check_route_sammler7b(int route,int x1,int y1, int x2, int y2)
{
	int dx,dy,x,y,y_mitte,element;
	int route_found = 0;
	dx=x2-x1;
	dy=y2-y1;
	element = elements[selected_box][find_element(x2+12*y2)][1];
	if((dx < 0) && ((element == 7) || (element == 8)) && (y1 < 7) && (y2 < 7))
	{
		y=y2+1;
		if((y1+1) > y) y=y1+1;
		while((y < 8) && (route_found == 0))
		{
			if ((y_connectable(x1+1,y1,y) + x_connectable(y,x1+1,x2) + y_connectable(x2,y,y2+1)) == 3) 
			{
				y_mitte = y;
				route_found = 1;
			}
			y++;
		}
		if(route_found == 0) return 0;

		if(debug_routing > 0) g_print ("sammler7b\n");
		//route zeichnen
		//vom Startpunkt nach unten
		x=x1+1;
		y=y1;
		field[x+12*y]=route+32;
		view_route_element(x+12*y,103);
		y++;

		while(y < y_mitte)
		{
			field[x+12*y]=route+32;
			view_route_element(x+12*y,101);
			y++;
		}

		field[x+12*y]=route+32;
		view_route_element(x+12*y,105);
		x--;

		while(x > x2)
		{
			field[x+12*y]=route+32;
			view_route_element(x+12*y,100);
			x--;
		}

		field[x+12*y]=route+32;
		view_route_element(x+12*y,104);
		y--;

		while(y > y2)
		{
			field[x+12*y]=route+32;
			view_route_element(x+12*y,101);
			y--;
		}
		return 1;
	}
	else
	{
		return 0;
	}
}


int calc_routes()
{
	div_t startpos,endpos;
	int x,y,z,dx,dy,x1,x2,y1,y2,z1,routed,element1,element2;
	int failure;

	if(debug_routing > 0) g_print ("Routing...\n");
	failure=0;

	//clear all routing information in workarea
	for(y=0;y<8;y++)
	{
		for(x=0;x<12;x++)
		{
			for(z1=0;z1<32;z1++)
			{
			//	work_area_route[y][x][z1]=0;
			}
		}
	}

	//now start routing
	for(z=0;z<32;z++)
	{
		if((routes[selected_box][z][0] < 255) && (routes[selected_box][z][1] < 255)) //valid route
		{
			element1=routes[selected_box][z][0];	//start element
			element2=routes[selected_box][z][1];	//end element

			startpos=div(elements[selected_box][element1][0],12);
			endpos=div(elements[selected_box][element2][0],12);
			x1=startpos.rem;
			y1=startpos.quot;
			x2=endpos.rem;
			y2=endpos.quot;
			dx=x2-x1;
			dy=y2-y1;

			if(debug_routing > 0) g_print ("Route Nr: %d from %d,%d to %d,%d\n",z,y1,x1,y2,x2);

			//horizontal
			routed = check_route_horizontal1(z,x1,y1,x2,y2);
			if (routed == 0) routed = check_route_horizontal2(z,x1,y1,x2,y2);
			if (routed == 0) routed = check_route_sammler6a(z,x1,y1,x2,y2);
			if (routed == 0) routed = check_route_sammler7a(z,x1,y1,x2,y2);
			if (routed == 0) routed = check_route_return1(z,x1,y1,x2,y2);
			if (routed == 0) routed = check_route_return2(z,x1,y1,x2,y2);
			if (routed == 0) routed = check_route_return3(z,x1,y1,x2,y2);
			if (routed == 0) routed = check_route_return4(z,x1,y1,x2,y2);
			if (routed == 0) routed = check_route_sammler6b(z,x1,y1,x2,y2);
			if (routed == 0) routed = check_route_sammler7b(z,x1,y1,x2,y2);
			if (routed == 0) routed = check_route_return3a(z,x1,y1,x2,y2);
			if (routed == 0) routed = check_route_return3b(z,x1,y1,x2,y2);
			if(routed == 0) 
			{
				failure = 1;
				if(debug_routing > 0) g_print ("*** CANNOT ROUTE ***\n");
			}
		} //valid route
	} // routes loop
	print_field();
	return failure;
}

