//################################################################################
//#                                                                              #
//# (c)2012-2013 Joerg Wolfram   joerg@jcwolfram.de                              #
//#                                                                              #
//# Dieses Programm ist freie Software. Sie können es unter den Bedingungen      #
//# der GNU General Public License, wie von der Free Software Foundation         #
//# veröffentlicht, weitergeben und/oder modifizieren, entweder gemäß            #
//# Version 3 der Lizenz oder (nach Ihrer Option) jeder späteren Version.        #
//#                                                                              #
//# Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, dass es       #
//# Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, auch ohne die     #
//# implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN          #
//# BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License.      #
//#                                                                              #
//# Sie sollten ein Exemplar der GNU General Public License zusammen mit         #
//# diesem Programm erhalten haben. Falls nicht, schreiben Sie an die Free       #
//# Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110,    #
//# USA.                                                                         #
//#                                                                              #
//# Jede Nutzung der Software/Informationen nonkonform zur GPL oder außerhalb    #
//# des Geltungsbereiches der GPL ist untersagt!                                 #
//#                                                                              #
//################################################################################
void view_route_element(int position,int symbol)
{
	//Element-Symbol zuweisen
	gtk_pixmap_set(	GTK_PIXMAP (field_pwid[position]),
			tiles_pixdat[symbol][0][0],
			tiles_mask[symbol][0][0]);

	field_pm[position][0] = symbol;
	field_pm[position][1] = 0;

	//DND drag zulassen
	gtk_drag_source_set(	field_bwid[position],
				GDK_BUTTON1_MASK,
				target_table,
				n_targets,
				GDK_ACTION_COPY | GDK_ACTION_MOVE);

	//DND icon festlegen
	gtk_drag_source_set_icon(	field_bwid[position],
					gtk_widget_get_colormap(element_list),
					tiles_pixdat[symbol][0][0],
					tiles_mask[symbol][0][0]);
}


//zeigt die Elemente an
void show_elements()
{
	int position,type,val,z,stat;

	for(position=0;position<96;position++)
	{
		field_pm[position][0] = 0;
		field_pm[position][1] = 0;
		z = 0;
		do
		{
			if (elements[selected_box][z][0] == position) //das Element z ist an dieser Position
			{
				type=elements[selected_box][z][1];
				val=elements[selected_box][z][2];

				field[position]=z;	//type

				stat=0;
				if(z == active_element) stat=1;
				if(z == conn_element) stat=2;

				gtk_pixmap_set(	GTK_PIXMAP (field_pwid[position]),
						tiles_pixdat[type][stat][val],
						tiles_mask[type][stat][val]);

				field_pm[position][0] = type;
				field_pm[position][1] = val;

				//DND drag enable
				gtk_drag_source_set(	field_bwid[position],
							GDK_BUTTON1_MASK,
							target_table,
							n_targets,
							GDK_ACTION_COPY | GDK_ACTION_MOVE);

				gtk_drag_source_set_icon(	field_bwid[position],
								gtk_widget_get_colormap(element_list),
								tiles_pixdat[type][0][0],
								tiles_mask[type][0][0]);
				z=99; //OK
			}
			z++;
		}
		while(z < 32);

		//das ist ein leeres feld
		if(z == 32)
		{
			gtk_pixmap_set(	GTK_PIXMAP (field_pwid[position]),
					tiles_pixdat[0][0][0],
					tiles_mask[0][0][0]);

			//DND drag disable
			gtk_drag_source_set(	field_bwid[position],
						0,
						target_table,
						n_targets,
						GDK_ACTION_COPY | GDK_ACTION_MOVE);

			gtk_drag_source_set_icon(	field_bwid[position],
							gtk_widget_get_colormap(element_list),
							tiles_pixdat[0][0][0],
							tiles_mask[0][0][0]);
			field[position]=255;	//type
		}
	} // position-loop
}

void show_adjust()
{
	int type,val;

	if(conn_element < 32)
	{
		gtk_pixmap_set(	GTK_PIXMAP (adjust_pwid),
				tiles_pixdat[119][0][0],
				tiles_mask[119][0][0]);
		gtk_label_set_text(GTK_LABEL(adjust_info),"Jetzt auf Zielfeld der Verbindung klicken");
		gtk_widget_hide(adjust_edit2);
	}
	else if(active_element < 32)
	{
		type=elements[selected_box][active_element][1];
		val=elements[selected_box][active_element][2];
		gtk_pixmap_set(	GTK_PIXMAP (adjust_pwid),
				tiles_pixdat[type][1][val],
				tiles_mask[type][1][val]);

		if(val > 0)
		{
			gtk_pixmap_set(	GTK_PIXMAP (adjust_num_pwid),
					adjust_pixdat[val],
					adjust_mask[val]);
			gtk_widget_show(adjust_edit2);
			gtk_label_set_text(GTK_LABEL(adjust_info),adjtext[type]);
		}
		else
		{
			gtk_label_set_text(GTK_LABEL(adjust_info),tooltext[type]);
			gtk_widget_hide(adjust_edit2);
		}
	}
	else
	{
		gtk_pixmap_set(	GTK_PIXMAP (adjust_pwid),
				tiles_pixdat[0][0][0],
				tiles_mask[0][0][0]);
		if(active_element != 104)
		{
			gtk_label_set_text(GTK_LABEL(adjust_info),"");
		}
		gtk_widget_hide(adjust_edit2);
	}
}



//Feld aus Array zusammenbauen
void load_field(int field)
{
	if(debug_callbacks == 1) g_print ("--- load_field(%d)\n",field);

	show_elements();

	if(is_error == 0)
	{
		show_adjust();
		gtk_widget_hide(adjust_ask);
	}
	else if (is_error == 1) 
	{
		is_error = 0;
		gtk_widget_hide(adjust_ask);
	}
	else if (is_error == 9) 
	{
	//	gtk_widget_hide(adjust_ask);
	}
	else
	{
		gtk_widget_hide(adjust_edit2);
		gtk_widget_show(adjust_ask);
	}
	//hier fehlt noch das routing
	route_error=calc_routes();

//	g_print ("RE: %d\n",route_error);
	if(route_error > 0) 
	{
		delete_last_route();
		show_elements();
		route_error=calc_routes();
	}
}

int find_element(int position)
{
	int z,result;
	result = 99;	//not found
	for(z=0;z<32;z++)
	{
		if(elements[selected_box][z][0] == position) result = z;
	}
	return result;
}

//------------------------------------------------------------------------------
//ein Element hinzufügen (DND aus Liste)
//------------------------------------------------------------------------------
int add_element(int position,int type,int value)
{
	int z,result;
	result = 99;	//not found
	if(debug_callbacks == 1) g_print ("---> add element\n");
	for(z=0;z<32;z++)
	{
		if((elements[selected_box][z][0] == 255) && (result == 99)) 
		{
			result = z;
			elements[selected_box][z][0]=position;
			elements[selected_box][z][1]=type;
			elements[selected_box][z][2]=value;
		}
	}
	return result;
}


void delete_element(int element)
{
	if(debug_callbacks == 1) g_print ("---> del element\n");
	elements[selected_box][element][0]=255;
	elements[selected_box][element][1]=255;
	elements[selected_box][element][2]=0;
	active_element=100;
	conn_element=100;
}

void print_field()
{
//	int x,y;
//	g_print ("FIELD:\n");
//	for(y=0;y<8;y++)
	{
//		for(x=0;x<12;x++) g_print("%4X",field[x+12*y]);
//		g_print ("\n");
	}
}

void save_data()
{
	int block,element,position,type,value,connect,route,i;

	fprintf(datei,"#LBlocks %d\n",VERSION);

	for(block=0;block<5;block++)
	{
		fprintf(datei,"===========================\n");
		fprintf(datei," Box NR POS TYP VAL CON NXT\n");
		for(element=0;element<32;element++)
		{
			if(elements[block][element][0] < 255)
			{
				position = elements[block][element][0];
				type     = elements[block][element][1];
				value    = elements[block][element][2];
				connect  = 255;
				route    = 99;
				for(i=0;i<32;i++)
				{
					if(routes[block][i][0] == element)
					{
						connect = routes[block][i][1];
						route = i;
					}
				}
				if(connect == 255) connect = 99;
				fprintf(datei,"* %d  %02d  %02d  %02d  %02d  %02d  %02d\n",
					block,element,position,type,value,route,connect);
			}
		}
	}
}


int load_data()
{
	int block,element,position,type,value,connect,route;
	char zeile0[100];

	fscanf(datei,"%s %d\n",&zeile0[0],&value);
	if(strcmp(zeile0,"#LBlocks") != 0) return 1;	//keine Lblocks Datei
	if(value > VERSION) return value;
	for(block=0;block<5;block++)
	{
		for(element=0;element<32;element++)
		{
			elements[block][element][0]=255;
			elements[block][element][1]=255;
			elements[block][element][2]=0;
		}
		for(route=0;route<32;route++)
		{
			routes[block][route][0]=255;
			routes[block][route][1]=255;
		}
	}
	
	
//	while(fscanf(datei," %d  %d  %d  %d  %d  %d  %d\n",block,element,position,type,value,route,connect) != EOF)
	while(fscanf(datei,"%s\n",&zeile0[0]) != EOF)
	{
//		g_print("%s\n",zeile1);
		if(strcmp(zeile0,"*") == 0)
		{
			fscanf(datei,"%d",&block);
			fscanf(datei,"%d",&element);
			fscanf(datei,"%d",&position);
			fscanf(datei,"%d",&type);
			fscanf(datei,"%d",&value);
			fscanf(datei,"%d",&route);
			fscanf(datei,"%d",&connect);

			if(connect > 32) connect = 255;
			elements[block][element][0]=position;
			elements[block][element][1]=type;
			elements[block][element][2]=value;
			if(route < 32)
			{
				routes[block][route][0]=element;
				routes[block][route][1]=connect;
			}
		}
	}

	gtk_pixmap_set(GTK_PIXMAP (tp_wid[10]),toolb[15], toolm[15] );
	gtk_pixmap_set(GTK_PIXMAP (tp_wid[11]),toolb[11], toolm[11] );
	gtk_pixmap_set(GTK_PIXMAP (tp_wid[12]),toolb[12], toolm[12] );
	gtk_pixmap_set(GTK_PIXMAP (tp_wid[13]),toolb[13], toolm[13] );
	gtk_pixmap_set(GTK_PIXMAP (tp_wid[14]),toolb[14], toolm[14] );
	selected_box=0;
	active_element=100;
	conn_element=100;
	load_field(selected_box);
	print_field();

	return 0;
}

//------------------------------------------------------------------------------
// write as screen shot as png image
//------------------------------------------------------------------------------
void save_screenshot()
{
	int xline,yline,xtile,ytile,position;
	int s_type,s_val,pix_index,pal_start,pix_start,ii,jj;
	png_bytep row;
	png_ptr = png_create_write_struct (PNG_LIBPNG_VER_STRING,NULL,NULL,NULL);
	info_ptr = png_create_info_struct (png_ptr);
	png_init_io(png_ptr,datei);
	png_set_IHDR(png_ptr,info_ptr,720,480,8,PNG_COLOR_TYPE_RGB,PNG_INTERLACE_NONE,PNG_COMPRESSION_TYPE_BASE,
		PNG_FILTER_TYPE_BASE);
	png_write_info(png_ptr,info_ptr);
	row=(png_bytep) malloc(2160 * sizeof(png_byte));
	
	for(ytile=0;ytile<8;ytile++)
	{
		for(yline=0;yline<60;yline++)
		{
			for(xtile=0;xtile<12;xtile++)
			{
				position=12*ytile+xtile;
				s_type=field_pm[position][0];
				s_val=field_pm[position][1];
				ii= 0;
				jj= (-1);
				while(jj == (-1))
				{
					if((s_type==tileval[ii*2]) && (s_val==tileval[ii*2+1]))
					{
						jj=ii;
					}
					if(tileval[ii*2] > 254)
					{
						jj=-2;
						g_print("UNKNOWN TILE %d  %d\n",s_type,s_val);
					}
					ii++;
				}
				if(jj >= 0)
				{
					pal_start=jj*(3600+68*3);
					pix_start=pal_start+68*3;
					for(xline=0;xline<60;xline++)
					{
						pix_index=tiledat[pix_start+xline+60*yline];
						row[xtile*180+xline*3]= tiledat[pal_start+3*pix_index];
						row[xtile*180+xline*3+1]=tiledat[pal_start+3*pix_index+1];
						row[xtile*180+xline*3+2]=tiledat[pal_start+3*pix_index+2];
					}
				}
				else
				{
					for(xline=0;xline<60;xline++)
					{
						row[xtile*180+xline*3]= 0;
						row[xtile*180+xline*3+1]=255;
						row[xtile*180+xline*3+2]=0;
					}
				}
				
			}
			png_write_row(png_ptr, row);
		}
	}
	png_write_end(png_ptr,NULL);
}

//------------------------------------------------------------------------------
// write a small screen shot into pixel map
//------------------------------------------------------------------------------
#if SIZE_TILE == 60
void small_image()
{
	int xline,yline,xtile,ytile,position,qx,qy,val_r,val_g,val_b,ir,ig,ib;
	int s_type,s_val,pix_index,pal_start,pix_start,ii,jj;
	char line[440];
	for(ytile=0;ytile<8;ytile++)
	{
		for(yline=0;yline<12;yline++)
		{
			for(xtile=0;xtile<12;xtile++)
			{
				position=12*ytile+xtile;
				s_type=field_pm[position][0];
				s_val=field_pm[position][1];
				ii= 0;
				jj= (-1);
				while(jj == (-1))
				{
					if((s_type==tileval[ii*2]) && (s_val==tileval[ii*2+1]))
					{
						jj=ii;
					}
					if(tileval[ii*2] > 254)
					{
						jj=-2;
						g_print("UNKNOWN TILE %d  %d\n",s_type,s_val);
					}
					ii++;
				}
				if(jj >= 0)
				{
					pal_start=jj*(3600+68*3);
					pix_start=pal_start+68*3;
					for(xline=0;xline<12;xline++)
					{
						val_r=0;
						val_g=0;
						val_b=0;
						for(qy=0;qy<5;qy++)
						{
							for(qx=0;qx<5;qx++)
							{
								pix_index=tiledat[pix_start+qx+5*xline+60*qy+300*yline];
								val_r += tiledat[pal_start+3*pix_index];
								val_g += tiledat[pal_start+3*pix_index+1];
								val_b += tiledat[pal_start+3*pix_index+2];
							}
						}
					min_pix[yline+12*ytile][xline+12*xtile][0] = (unsigned char)(val_r / 25);
						min_pix[yline+12*ytile][xline+12*xtile][1] = (unsigned char)(val_g / 25);
						min_pix[yline+12*ytile][xline+12*xtile][2] = (unsigned char)(val_b / 25);
					}
				}
			}
		}
	}
	sprintf (temp_xpm[0],"144 96 216 3");
	for (ir=0;ir<6;ir++)
	{
		for (ig=0;ig<6;ig++)
		{
			for (ib=0;ib<6;ib++)
			{
//				printf("\"%c%c%c\tc #%02X%02X%02X\",\n",65+ir,65+ig,65+ib,50*ir,50*ig,50*ib);
				sprintf (temp_xpm[1+ib+6*ig+36*ir],"%c%c%c\tc #%02X%02X%02X",65+ir,65+ig,65+ib,50*ir,50*ig,50*ib);
			}
		}
	}
	for(yline=0;yline<96;yline++)
	{
		line[432]=0;
		for(xline=0;xline<144;xline++)
		{
			val_r= min_pix[yline][xline][0];
			ir=65;
			if(val_r > 25) ir = 66;
			if(val_r > 75) ir = 67;
			if(val_r > 125) ir = 68;
			if(val_r > 175) ir = 69;
			if(val_r > 225) ir = 70;

			val_g= min_pix[yline][xline][1];
			ig=65;
			if(val_g > 25) ig = 66;
			if(val_g > 75) ig = 67;
			if(val_g > 125) ig = 68;
			if(val_g > 175) ig = 69;
			if(val_g > 225) ig = 70;

			val_b= min_pix[yline][xline][2];
			ib=65;
			if(val_b > 25) ib = 66;
			if(val_b > 75) ib = 67;
			if(val_b > 125) ib = 68;
			if(val_b > 175) ib = 69;
			if(val_b > 225) ib = 70;

			line[xline*3]=ir;
			line[xline*3+1]=ig;
			line[xline*3+2]=ib;
		}
//		printf("\"%s\",\n",line);
		sprintf(temp_xpm[217+yline],"%s",line);
	}
}
#endif

#if SIZE_TILE == 40
void small_image()
{
	int xline,yline,xtile,ytile,position,qx,qy,val_r,val_g,val_b,ir,ig,ib;
	int s_type,s_val,pix_index,pal_start,pix_start,ii,jj;
	char line[440];
	for(ytile=0;ytile<8;ytile++)
	{
		for(yline=0;yline<8;yline++)
		{
			for(xtile=0;xtile<12;xtile++)
			{
				position=12*ytile+xtile;
				s_type=field_pm[position][0];
				s_val=field_pm[position][1];
				ii= 0;
				jj= (-1);
				while(jj == (-1))
				{
					if((s_type==tileval[ii*2]) && (s_val==tileval[ii*2+1]))
					{
						jj=ii;
					}
					if(tileval[ii*2] > 254)
					{
						jj=-2;
						g_print("UNKNOWN TILE %d  %d\n",s_type,s_val);
					}
					ii++;
				}
				if(jj >= 0)
				{
					pal_start=jj*(3600+68*3);
					pix_start=pal_start+68*3;
					for(xline=0;xline<8;xline++)
					{
						val_r=0;
						val_g=0;
						val_b=0;
						for(qy=0;qy<7;qy++)
						{
							for(qx=0;qx<7;qx++)
							{
								pix_index=tiledat[pix_start+qx+7*xline+60*qy+420*yline];
								val_r += tiledat[pal_start+3*pix_index];
								val_g += tiledat[pal_start+3*pix_index+1];
								val_b += tiledat[pal_start+3*pix_index+2];
							}
						}
					min_pix[yline+8*ytile][xline+8*xtile][0] = (unsigned char)(val_r / 49);
						min_pix[yline+8*ytile][xline+8*xtile][1] = (unsigned char)(val_g / 49);
						min_pix[yline+8*ytile][xline+8*xtile][2] = (unsigned char)(val_b / 49);
					}
				}
			}
		}
	}
	sprintf (temp_xpm[0],"96 64 216 3");
	for (ir=0;ir<6;ir++)
	{
		for (ig=0;ig<6;ig++)
		{
			for (ib=0;ib<6;ib++)
			{
//				printf("\"%c%c%c\tc #%02X%02X%02X\",\n",65+ir,65+ig,65+ib,50*ir,50*ig,50*ib);
				sprintf (temp_xpm[1+ib+6*ig+36*ir],"%c%c%c\tc #%02X%02X%02X",65+ir,65+ig,65+ib,50*ir,50*ig,50*ib);
			}
		}
	}
	for(yline=0;yline<64;yline++)
	{
		line[288]=0;
		for(xline=0;xline<96;xline++)
		{
			val_r= min_pix[yline][xline][0];
			ir=65;
			if(val_r > 25) ir = 66;
			if(val_r > 75) ir = 67;
			if(val_r > 125) ir = 68;
			if(val_r > 175) ir = 69;
			if(val_r > 225) ir = 70;

			val_g= min_pix[yline][xline][1];
			ig=65;
			if(val_g > 25) ig = 66;
			if(val_g > 75) ig = 67;
			if(val_g > 125) ig = 68;
			if(val_g > 175) ig = 69;
			if(val_g > 225) ig = 70;

			val_b= min_pix[yline][xline][2];
			ib=65;
			if(val_b > 25) ib = 66;
			if(val_b > 75) ib = 67;
			if(val_b > 125) ib = 68;
			if(val_b > 175) ib = 69;
			if(val_b > 225) ib = 70;

			line[xline*3]=ir;
			line[xline*3+1]=ig;
			line[xline*3+2]=ib;
		}
//		printf("\"%s\",\n",line);
		sprintf(temp_xpm[217+yline],"%s",line);
	}
}
#endif


void testwrite()
{
	int xline,yline;
	png_bytep row;
	png_ptr = png_create_write_struct (PNG_LIBPNG_VER_STRING,NULL,NULL,NULL);
	info_ptr = png_create_info_struct (png_ptr);
	png_init_io(png_ptr,datei);
	png_set_IHDR(png_ptr,info_ptr,120,80,8,PNG_COLOR_TYPE_RGB,PNG_INTERLACE_NONE,PNG_COMPRESSION_TYPE_BASE,
		PNG_FILTER_TYPE_BASE);
	png_write_info(png_ptr,info_ptr);
	row=(png_bytep) malloc(480 * sizeof(png_byte));
	for(yline=0;yline<80;yline++)
	{
		for(xline=0;xline<120;xline++)
		{
			row[xline*3]= min_pix[yline][xline][0];
			row[xline*3+1]= min_pix[yline][xline][1];
			row[xline*3+2]= min_pix[yline][xline][2];
		}
		png_write_row(png_ptr, row);
	}
	png_write_end(png_ptr,NULL);
}

//------------------------------------------------------------------------------
// get a backup of current data
//------------------------------------------------------------------------------
void backup_current()
{
	int x,y,z;
	for(x=0;x<5;x++)
	{
		for(y=0;y<32;y++)
		{
			for(z=0;z<3;z++)
			{
				elements_backup[x][y][z] = elements[x][y][z];
			}
			for(z=0;z<2;z++)
			{
				routes_backup[x][y][z] = routes[x][y][z];
			}
		}
	}
	strcpy(project_name_backup,project_name);
}

//------------------------------------------------------------------------------
// restore current data
//------------------------------------------------------------------------------
void restore_current()
{
	int x,y,z;
	for(x=0;x<5;x++)
	{
		for(y=0;y<32;y++)
		{
			for(z=0;z<3;z++)
			{
				elements[x][y][z] = elements_backup[x][y][z];
			}
			for(z=0;z<2;z++)
			{
				routes[x][y][z] = routes_backup[x][y][z];
			}
		}
	}
	strcpy(project_name,project_name_backup);
}

void read_pnames()
{
	int j;
	for(j=0;j<31;j++)
	{
		pname1[j]=memdat[0x200+j];
		pname2[j]=memdat[0x600+j];
		pname3[j]=memdat[0xa00+j];
		pname4[j]=memdat[0xe00+j];
	}
	pname1[31]=0;
	pname2[31]=0;
	pname3[31]=0;
	pname4[31]=0;
}

void init_elements(int p)
{
	int x;

	for(x=0;x<32;x++)
	{
		routes[p][x][0]=255;	//undef
		routes[p][x][1]=255;	//undef
	}

	for(x=0;x<32;x++)
	{
		elements[p][x][0]=255;	//keine POS
		elements[p][x][1]=255;	//invalid
		elements[p][x][2]=0;	//no adjust
	}

	if(p==0)
	{
		elements[p][0][0]=24;
		elements[p][0][1]=2;
	}
	else
	{
		elements[p][0][0]=36;
		elements[p][0][1]=4;
		elements[p][1][0]=47;
		elements[p][1][1]=5;
		routes[p][0][0]=0;
		routes[p][0][1]=1;
	}
}

